package generated.eGKmitServices.terminal.apothekenPC;

//import swt.simulation.SmartCardSimulation;
import swt.terminal.HandleResult;
import swt.util.ByteArray;
import swt.util.HexString;
import de.uniaugsburg.swt.javacard.terminalinterface.SWTReader;
import de.uniaugsburg.swt.javacard.terminalinterface.SWTReaderException;
import javax.xml.ws.BindingProvider;

public class ApothekenPC {

	private byte zustand;

	private Nonce nonce;

	private ZertifikatLeistungserbringer zertLeistungserbringer;

	private ZertifikatTrustedThirdParty zertTTP;

	private ZertifikatPatient zertPatient;

	private SymmKey sessionkey;

	private Secret pinegk;

	private Secret pinhba;

	private int idLeistungserbringerPC;

	private boolean authBeide;

	private boolean schluesselAusgetauscht;

	private int index;

	private ListOfERezeptdaten eingeloest;

	private Userinterface userinterface;
	public void setUserinterface(Userinterface u) {
		this.userinterface = u;
	}

	// saved prev message
	public byte[] prevMsg;
	public Usermessage prevUMsg;

	public final Gate dummyGate = new Gate() {
		@Override
		public void callConstraints() {
			/* do nothing */
		}

		@Override
		public byte[] transmit(ApothekenPC terminal, byte[] apdu, int port)
				throws TerminalException, SWTReaderException {
			return terminal.transmit(apdu, port);
		}

		@Override
		public void finishProtocol(ApothekenPC terminal) {
			/* do nothing */
		}

	};
	public Gate currentGate = dummyGate;

	/**
	 * Resets the current gate to a default dummy gate
	 */
	public void resetGate() {
		currentGate = dummyGate;
	}

	/**
	 * Sets the current gate
	 */
	public void setGate(Gate gate) {
		currentGate = gate;
	}

	public ApothekenPC() throws java.lang.Exception {

		zustand = ZustandLeistungserbringerPC.IDLE;
		nonce = new Nonce();
		zertLeistungserbringer = new ZertifikatLeistungserbringer();
		zertTTP = new ZertifikatTrustedThirdParty();
		zertPatient = new ZertifikatPatient();
		sessionkey = new SymmKey();
		pinegk = new Secret();
		pinhba = new Secret();
		idLeistungserbringerPC = 0;
		authBeide = false;
		schluesselAusgetauscht = false;
		index = 0;
		eingeloest = new ListOfERezeptdaten();

	}

	public ApothekenPC(int idLeistungserbringerPC,
			ZertifikatTrustedThirdParty zertTTP, byte zustand)
			throws java.lang.Exception {

		this.idLeistungserbringerPC = idLeistungserbringerPC;
		this.zertTTP = zertTTP;
		this.zustand = zustand;

		nonce = new Nonce();
		zertLeistungserbringer = new ZertifikatLeistungserbringer();
		zertPatient = new ZertifikatPatient();
		sessionkey = new SymmKey();
		pinegk = new Secret();
		pinhba = new Secret();
		authBeide = false;
		schluesselAusgetauscht = false;
		index = 0;
		eingeloest = new ListOfERezeptdaten();

	}

	private void sendMsg(Message msg) {

		currentGate.callConstraints();
		userinterface.send((Usermessage) msg);

	}

	private void sendMsg(Message msg, int port) throws java.lang.Exception {

		sendMsg(msg, port, false, false);

	}
	private void sendMsg(Message msg, int port, Boolean openSessionBeforeSend,
			Boolean closeSessionAfterReceive) throws java.lang.Exception {

		currentGate.callConstraints();

		Message response;

		switch (port) {
			case Ports.ApothekenPC2Gesundheitskarte_default :
				response = sendCardMsg(msg, port);
				if (response != null)
					processMessage(response);
				break;

			case Ports.ApothekenPC2HeilberufsausweisApotheker_default :
				response = sendCardMsg(msg, port);
				if (response != null)
					processMessage(response);
				break;

			default :
				stop();
		}
	}

	private Message sendCardMsg(Message msg, int port)
			throws java.lang.Exception {
		byte[] encMsg = new byte[LengthConstants.MAX_ENCODING_LENGTH_MESSAGES];
		short encMsgLen = Coding.getInstance().encode((Codeable) msg, encMsg);
		encMsg = ByteArray.subarray(encMsg, 0, encMsgLen);
		byte[] apdu = ByteArray.append(new byte[]{0, 2, 0, 0, 0}, encMsg);
		byte[] response = currentGate.transmit(this, apdu, port);

		if (response.length == 2) {
			if (!(response[0] == (byte) 0x90 && response[1] == (byte) 0x00))
				throw new TerminalException("Cardexception: "
						+ HandleResult.interpretSW(response));
			return null;
		} else {
			prevMsg = response;

			Coding.getInstance().decodeInit();
			Codeable cResponse = Coding.getInstance().decode(response);
			return (Message) cResponse;
		}
	}

	/**
	 * Processes a raw data stream by trying to decode data to Message.
	 * Needed for testcases.
	 * @param data
	 */
	public void processRawMessage(byte[] data) {
		prevMsg = data;
		try {
			Coding.getInstance().decodeInit();
			Codeable cResponse = Coding.getInstance().decode(data);
			processMessage((Message) cResponse);
		} catch (java.lang.Exception e) {
			System.err.println("Failed decoding data in processRawMessage");
		}

	}

	private void processMessage(Message inmsg) throws java.lang.Exception {
		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.UREZEPTEINLOESEN :
				processURezeptEinloesen((URezeptEinloesen) inmsg);
				break;
			case Code.SENDENONCEFUEREINLOESEN :
				processSendeNonceFuerEinloesen((SendeNonceFuerEinloesen) inmsg);
				break;
			case Code.SENDEREZEPTZUMEINLOESEN :
				processSendeRezeptZumEinloesen((SendeRezeptZumEinloesen) inmsg);
				break;
			case Code.UVALIDATEPINHBA :
				processUValidatePINHBA((UValidatePINHBA) inmsg);
				break;
			case Code.SENDENONCEHBAPIN :
				processSendeNonceHBApin((SendeNonceHBApin) inmsg);
				break;
			case Code.BESTAETIGEPINHBA :
				processBestaetigePINHBA((BestaetigePINHBA) inmsg);
				break;
			case Code.USTARTAUTH :
				processUStartAuth((UStartAuth) inmsg);
				break;
			case Code.RETAUTHENTISIEREHBA :
				processRetAuthentisiereHBA((RetAuthentisiereHBA) inmsg);
				break;
			case Code.RETSENDECHALLENGEHBA :
				processRetSendeChallengeHBA((RetSendeChallengeHBA) inmsg);
				break;
			case Code.RETAUTHENTISIEREEGK :
				processRetAuthentisiereEGK((RetAuthentisiereEGK) inmsg);
				break;
			case Code.RETSENDECHALLENGEEGK :
				processRetSendeChallengeEGK((RetSendeChallengeEGK) inmsg);
				break;
			case Code.SENDECHALLENGEHBA :
				processSendeChallengeHBA((SendeChallengeHBA) inmsg);
				break;
			case Code.SENDECHALLENGEEGK :
				processSendeChallengeEGK((SendeChallengeEGK) inmsg);
				break;
			case Code.ENDAUTH :
				processEndAuth((EndAuth) inmsg);
				break;
			case Code.USTARTSCHLUESSELAUSTAUSCH :
				processUStartSchluesselaustausch((UStartSchluesselaustausch) inmsg);
				break;
			case Code.SENDENONCEVERSCHLUESSELTHBA :
				processSendeNonceVerschluesseltHBA((SendeNonceVerschluesseltHBA) inmsg);
				break;
			case Code.ERFRAGENONCEEGK :
				processErfrageNonceEGK((ErfrageNonceEGK) inmsg);
				break;
			case Code.SENDENONCEVERSCHLUESSELTEGK :
				processSendeNonceVerschluesseltEGK((SendeNonceVerschluesseltEGK) inmsg);
				break;
			case Code.SENDESESSIONKEY :
				processSendeSessionkey((SendeSessionkey) inmsg);
				break;
			case Code.BESTAETIGESCHLUESSELAUSTAUSCH :
				processBestaetigeSchluesselaustausch((BestaetigeSchluesselaustausch) inmsg);
				break;
			case Code.UVALIDATEPINEGK :
				processUValidatePINEGK((UValidatePINEGK) inmsg);
				break;
			case Code.SENDENONCEEGKPIN :
				processSendeNonceEGKpin((SendeNonceEGKpin) inmsg);
				break;
			case Code.BESTAETIGEPINEGK :
				processBestaetigePINEGK((BestaetigePINEGK) inmsg);
				break;
			default :
				stop();
		}

		currentGate.callConstraints();
		currentGate.finishProtocol(this);
	}

	public void process(Message msg) throws TerminalException {
		currentGate.callConstraints();

		try {
			if (msg instanceof Usermessage)
				prevUMsg = (Usermessage) msg;
			processMessage(msg);
		} catch (java.lang.Exception e) {
			// e.printStackTrace();
			if (e instanceof TerminalException)
				throw (TerminalException) e;
			else
				throw new TerminalException(
						"Error when calling process method: " + e);
		}

		currentGate.callConstraints();
		currentGate.finishProtocol(this);
	}

	private final static int MAX_SPLIT_LENGTH = 50;
	private final static int MAX_APDU_LENGTH = 254;
	private final static int APDU_HEADER_LENGTH = 5;
	private final static int APDU_DATA_LENTH = MAX_APDU_LENGTH
			- APDU_HEADER_LENGTH;
	private SWTReader[] reader = new SWTReader[5];

	public void initReader(SWTReader reader, int port) {
		this.reader[port] = reader;
	}

	public byte[] encode(Codeable c) throws java.lang.Exception {
		byte[] encMsg = new byte[LengthConstants.MAX_ENCODING_LENGTH_MESSAGES];
		short encMsgLen = Coding.getInstance().encode(c, encMsg);
		return ByteArray.subarray(encMsg, 0, encMsgLen);
	}

	public byte[] transmit(byte[] apdu, int port) throws TerminalException,
			SWTReaderException {
		byte[] received = null;
		if (apdu.length <= MAX_APDU_LENGTH) {
			apdu[4] = (byte) (apdu.length - 5);
			received = reader[port].transmit(apdu);
			if (received.length == 2)
				return received;
			received = ByteArray.subarray(received, 0, received.length - 2);
		} else {
			byte[] splittedApdu;
			byte[] apduHeader = ByteArray.subarray(apdu, 0, APDU_HEADER_LENGTH);
			apdu = ByteArray.subarray(apdu, APDU_HEADER_LENGTH);
			int splitCount = apdu.length / APDU_DATA_LENTH;
			if (apdu.length % APDU_DATA_LENTH != 0)
				splitCount++;
			for (int i = 0; i < splitCount; i++) {
				if (i == splitCount - 1) {
					splittedApdu = ByteArray
							.subarray(apdu, i * APDU_DATA_LENTH);
					apduHeader[2] = (byte) 0;
					apduHeader[4] = (byte) splittedApdu.length;
					splittedApdu = ByteArray.append(apduHeader, splittedApdu);
					received = reader[port].transmit(splittedApdu);
					if (received.length == 2)
						return received;
					received = ByteArray.subarray(received, 0,
							received.length - 2);
				} else {
					splittedApdu = ByteArray.subarray(apdu,
							i * APDU_DATA_LENTH, APDU_DATA_LENTH);
					apduHeader[2] = (byte) 1;
					apduHeader[4] = (byte) splittedApdu.length;
					splittedApdu = ByteArray.append(apduHeader, splittedApdu);
					received = reader[port].transmit(splittedApdu);
					if (!(received[0] == (byte) 0x90 && received[1] == (byte) 0x00)) {
						throw new TerminalException(
								"Bad answer from card: part of a long APDU was not answered with OK (0x9000).");
					}
				}
			}
		}

		for (int i = 0; i < MAX_SPLIT_LENGTH; i++) {
			if (received[0] == 0) {
				received = ByteArray.subarray(received, 1);
				return received;
			} else if (received[0] == 1) {
				received = ByteArray.subarray(received, 1);
				byte[] getMore = new byte[]{0, 6, 0, 0, 0, 1, 1};
				byte[] temp_received = reader[port].transmit(getMore);

				temp_received = ByteArray.subarray(temp_received, 0,
						temp_received.length - 2);
				received = ByteArray.append(temp_received[0], received);
				temp_received = ByteArray.subarray(temp_received, 1);
				received = ByteArray.append(received, temp_received);
			} else
				throw new TerminalException(
						"Bad answer from card: answer to a long APDU must begin with 0 or 1.");
		}
		return received;
	}

	/**
	 * This method initializes the card with the given parameters that correspond 
	 * to the card attributes. A null value will be ignored by the card.
	 * @throws Exception
	 */
	public void initCard_Gesundheitskarte(int port,
			Versichertenstammdaten daten, Secret pin, PrivateKey privkeyEGK,
			PublicKey providerKey, SignedData sigdaten, ZertifikatPatient zert,
			ZertifikatTrustedThirdParty zertTTP, byte zustand)
			throws java.lang.Exception {
		byte cardCode = 0x0;
		switch (port) {
			case Ports.ApothekenPC2Gesundheitskarte_default :
				cardCode = Code.GESUNDHEITSKARTE;
				break;
			case Ports.ApothekenPC2HeilberufsausweisApotheker_default :
				cardCode = Code.HEILBERUFSAUSWEISAPOTHEKER;
				break;
			default :
				stop();
				break;
		}
		byte[] apdu = {0, 4, 0, 0, 0, cardCode};
		apdu = ByteArray.append(apdu, (daten != null)
				? encode(daten)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (pin != null)
				? encode(pin)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (privkeyEGK != null)
				? encode(privkeyEGK)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (providerKey != null)
				? encode(providerKey)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (sigdaten != null)
				? encode(sigdaten)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zert != null)
				? encode(zert)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zertTTP != null)
				? encode(zertTTP)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, new byte[]{Code.BYTE, zustand});
		transmit(apdu, port);
	}
	/**
	 * This method initializes the card with the given parameters that correspond 
	 * to the card attributes. A null value will be ignored by the card.
	 * @throws Exception
	 */
	public void initCard_HeilberufsausweisArzt(int port, Secret pin,
			PrivateKey privkeyHBA, ZertifikatLeistungserbringer zert,
			ZertifikatTrustedThirdParty zertTTP, byte zustand)
			throws java.lang.Exception {
		byte cardCode = 0x0;
		switch (port) {
			case Ports.ApothekenPC2Gesundheitskarte_default :
				cardCode = Code.GESUNDHEITSKARTE;
				break;
			case Ports.ApothekenPC2HeilberufsausweisApotheker_default :
				cardCode = Code.HEILBERUFSAUSWEISAPOTHEKER;
				break;
			default :
				stop();
				break;
		}
		byte[] apdu = {0, 4, 0, 0, 0, cardCode};
		apdu = ByteArray.append(apdu, (pin != null)
				? encode(pin)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (privkeyHBA != null)
				? encode(privkeyHBA)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zert != null)
				? encode(zert)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zertTTP != null)
				? encode(zertTTP)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, new byte[]{Code.BYTE, zustand});
		transmit(apdu, port);
	}
	/**
	 * This method initializes the card with the given parameters that correspond 
	 * to the card attributes. A null value will be ignored by the card.
	 * @throws Exception
	 */
	public void initCard_HeilberufsausweisApotheker(int port, Secret pin,
			PrivateKey privkeyHBA, ZertifikatLeistungserbringer zert,
			ZertifikatTrustedThirdParty zertTTP, byte zustand)
			throws java.lang.Exception {
		byte cardCode = 0x0;
		switch (port) {
			case Ports.ApothekenPC2Gesundheitskarte_default :
				cardCode = Code.GESUNDHEITSKARTE;
				break;
			case Ports.ApothekenPC2HeilberufsausweisApotheker_default :
				cardCode = Code.HEILBERUFSAUSWEISAPOTHEKER;
				break;
			default :
				stop();
				break;
		}
		byte[] apdu = {0, 4, 0, 0, 0, cardCode};
		apdu = ByteArray.append(apdu, (pin != null)
				? encode(pin)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (privkeyHBA != null)
				? encode(privkeyHBA)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zert != null)
				? encode(zert)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zertTTP != null)
				? encode(zertTTP)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, new byte[]{Code.BYTE, zustand});
		transmit(apdu, port);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processURezeptEinloesen(URezeptEinloesen inmsg)
			throws java.lang.Exception {
		int n = inmsg.getIndex();
		if (((((zustand == ZustandLeistungserbringerPC.IDLE && authBeide) && schluesselAusgetauscht) && idLeistungserbringerPC == Constants.idApothekenPC) && zertLeistungserbringer
				.getData().getId() == Constants.idApotheker)) {
			setIndex(n);
			setZustand(ZustandLeistungserbringerPC.WARTEAUFNONCE);
			sendMsg(new ErfrageNonceFuerEinloesen(),
					Ports.ApothekenPC2Gesundheitskarte_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeNonceFuerEinloesen(SendeNonceFuerEinloesen inmsg)
			throws java.lang.Exception {
		Nonce n = inmsg.getNonce();
		if (zustand == ZustandLeistungserbringerPC.WARTEAUFNONCE) {
			setNonce(Nonce.generateNonce());
			IndexNonce i = new IndexNonce(index, n, nonce);
			EncDataSymm eds = EncDataSymm.encrypt(sessionkey, i);
			setZustand(ZustandLeistungserbringerPC.WARTEAUFREZEPT);
			sendMsg(new Einloesen(eds),
					Ports.ApothekenPC2Gesundheitskarte_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeRezeptZumEinloesen(SendeRezeptZumEinloesen inmsg)
			throws java.lang.Exception {
		EncDataSymm eds = inmsg.getRezeptdatenUNonce();
		SignedData sig = inmsg.getSig();
		ZertifikatLeistungserbringer zertArzt = inmsg.getZertArzt();
		RezeptdatenUndNonce rd = (RezeptdatenUndNonce) (EncDataSymm.decrypt(
				sessionkey, eds));
		if ((((zustand == ZustandLeistungserbringerPC.WARTEAUFREZEPT && zertArzt
				.verifyCertificate(zertTTP.getData().getPubkey())) && SignedData
				.verify(zertArzt.getData().getPubkey(), sig,
						rd.getRezeptdaten())) && rd.getNonceApothekenPC()
				.equals(nonce))) {
			eingeloest.add(rd.getRezeptdaten());
			setZustand(ZustandLeistungserbringerPC.IDLE);
			sendMsg(new URezeptausgabe(rd.getRezeptdaten()));
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUValidatePINHBA(UValidatePINHBA inmsg)
			throws java.lang.Exception {
		Secret pin = inmsg.getPin();
		if ((zustand == ZustandLeistungserbringerPC.IDLE && authBeide)) {
			setZustand(ZustandLeistungserbringerPC.WNONCEHBApin);
			setPinhba(pin);
			sendMsg(new ErfrageNonceHBApin(),
					Ports.ApothekenPC2HeilberufsausweisApotheker_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeNonceHBApin(SendeNonceHBApin inmsg)
			throws java.lang.Exception {
		Nonce n = inmsg.getN();
		if (zustand == ZustandLeistungserbringerPC.WNONCEHBApin) {
			PINData pindata = new PINData(pinhba, n);
			EncDataAsymm eds = EncDataAsymm.encrypt(zertLeistungserbringer
					.getData().getPubkey(), pindata);
			setZustand(ZustandLeistungserbringerPC.WBESTHBAPIN);
			sendMsg(new SendePINHBA(eds),
					Ports.ApothekenPC2HeilberufsausweisApotheker_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processBestaetigePINHBA(BestaetigePINHBA inmsg)
			throws java.lang.Exception {

		if (zustand == ZustandLeistungserbringerPC.WBESTHBAPIN) {
			setZustand(ZustandLeistungserbringerPC.IDLE);
			sendMsg(new UBestaetigePINHBA());
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUStartAuth(UStartAuth inmsg) throws java.lang.Exception {

		if (zustand == ZustandLeistungserbringerPC.IDLE) {
			setZustand(ZustandLeistungserbringerPC.AUTHA);
			sendMsg(new AuthentisiereHBA(),
					Ports.ApothekenPC2HeilberufsausweisApotheker_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processRetAuthentisiereHBA(RetAuthentisiereHBA inmsg)
			throws java.lang.Exception {
		ZertifikatLeistungserbringer zert = inmsg.getZertArzt();
		if (((zustand == ZustandLeistungserbringerPC.AUTHA && zert
				.verifyCertificate(zertTTP.getData().getPubkey())) && ((zert
				.getData().getId() == Constants.idArzt || zert.getData()
				.getId() == Constants.idApotheker)))) {
			setZertLeistungserbringer(zert);
			setZustand(ZustandLeistungserbringerPC.AUTHB);
			sendMsg(new SendeZertifikatHBA(zert),
					Ports.ApothekenPC2Gesundheitskarte_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processRetSendeChallengeHBA(RetSendeChallengeHBA inmsg)
			throws java.lang.Exception {
		Nonce nonceCard = inmsg.getNonceCard();
		Nonce nonceTerm = inmsg.getNonceTerm();
		if ((zustand == ZustandLeistungserbringerPC.AUTHC && nonce
				.equals(nonceTerm))) {
			setZustand(ZustandLeistungserbringerPC.AUTHD);
			sendMsg(new AuthentisiereEGK(nonceCard),
					Ports.ApothekenPC2Gesundheitskarte_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processRetAuthentisiereEGK(RetAuthentisiereEGK inmsg)
			throws java.lang.Exception {
		ZertifikatPatient zert = inmsg.getZertPatient();
		if (((zustand == ZustandLeistungserbringerPC.AUTHD && zert
				.verifyCertificate(zertTTP.getData().getPubkey())) && zert
				.getData().getId() == Constants.idGesundheitskarte)) {
			setZertPatient(zert);
			setZustand(ZustandLeistungserbringerPC.AUTHE);
			sendMsg(new RetAuthentisiereEGKWeiter(zert),
					Ports.ApothekenPC2HeilberufsausweisApotheker_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processRetSendeChallengeEGK(RetSendeChallengeEGK inmsg)
			throws java.lang.Exception {
		Nonce nonceCard = inmsg.getNonceCard();
		Nonce nonceTerm = inmsg.getNonceTerm();
		if ((zustand == ZustandLeistungserbringerPC.AUTHF && nonce
				.equals(nonceTerm))) {
			setAuthBeide(true);
			setZustand(ZustandLeistungserbringerPC.IDLE);
			sendMsg(new RetSendeChallengeEGKWeiter(nonceCard),
					Ports.ApothekenPC2HeilberufsausweisApotheker_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeChallengeHBA(SendeChallengeHBA inmsg)
			throws java.lang.Exception {
		EncDataAsymm encCard = inmsg.getEncryptedNonce();
		if (zustand == ZustandLeistungserbringerPC.AUTHB) {
			setNonce(Nonce.generateNonce());
			NonceData nd = new NonceData(nonce);
			EncDataAsymm enc = EncDataAsymm.encrypt(zertLeistungserbringer
					.getData().getPubkey(), nd);
			setZustand(ZustandLeistungserbringerPC.AUTHC);
			sendMsg(new SendeChallengeHBAWeiter(encCard, enc),
					Ports.ApothekenPC2HeilberufsausweisApotheker_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeChallengeEGK(SendeChallengeEGK inmsg)
			throws java.lang.Exception {
		EncDataAsymm encCard = inmsg.getEncryptedNonce();
		if (zustand == ZustandLeistungserbringerPC.AUTHE) {
			setNonce(Nonce.generateNonce());
			NonceData nd = new NonceData(nonce);
			EncDataAsymm enc = EncDataAsymm.encrypt(zertPatient.getData()
					.getPubkey(), nd);
			setZustand(ZustandLeistungserbringerPC.AUTHF);
			sendMsg(new SendeChallengeEGKWeiter(encCard, enc),
					Ports.ApothekenPC2Gesundheitskarte_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processEndAuth(EndAuth inmsg) throws java.lang.Exception {

		sendMsg(new UEndAuth());
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUStartSchluesselaustausch(
			UStartSchluesselaustausch inmsg) throws java.lang.Exception {

		if ((zustand == ZustandLeistungserbringerPC.IDLE && authBeide)) {
			setZustand(ZustandLeistungserbringerPC.SCHLUESSELAUSTAUSCHA);
			sendMsg(new ErfrageNonceHBA(),
					Ports.ApothekenPC2HeilberufsausweisApotheker_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeNonceVerschluesseltHBA(
			SendeNonceVerschluesseltHBA inmsg) throws java.lang.Exception {
		EncDataSymm enc = inmsg.getEnc();
		if (zustand == ZustandLeistungserbringerPC.SCHLUESSELAUSTAUSCHA) {
			setSessionkey(SymmKey.generateKey());
			SecretNonceData nd = (SecretNonceData) (EncDataSymm.decrypt(
					SymmKey.generateKeyFromSecret(pinhba), enc));
			setNonce(nd.getNonce());
			KeyData kd = new KeyData(nonce, sessionkey);
			EncDataAsymm encC = EncDataAsymm.encrypt(zertLeistungserbringer
					.getData().getPubkey(), kd);
			setSchluesselAusgetauscht(true);
			setZustand(ZustandLeistungserbringerPC.IDLE);
			sendMsg(new SendeSchluessel(encC),
					Ports.ApothekenPC2HeilberufsausweisApotheker_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processErfrageNonceEGK(ErfrageNonceEGK inmsg)
			throws java.lang.Exception {

		sendMsg(new ErfrageNonceEGKWeiter(),
				Ports.ApothekenPC2Gesundheitskarte_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeNonceVerschluesseltEGK(
			SendeNonceVerschluesseltEGK inmsg) throws java.lang.Exception {
		EncDataAsymm enc = inmsg.getEnc();
		sendMsg(new SendeNonceVerschluesseltEGKWeiter(enc),
				Ports.ApothekenPC2HeilberufsausweisApotheker_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeSessionkey(SendeSessionkey inmsg)
			throws java.lang.Exception {
		EncDataAsymm enc = inmsg.getEnc();
		sendMsg(new SendeSessionkeyWeiter(enc),
				Ports.ApothekenPC2Gesundheitskarte_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processBestaetigeSchluesselaustausch(
			BestaetigeSchluesselaustausch inmsg) throws java.lang.Exception {

		sendMsg(new UBestaetigeSchluesselaustausch());
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUValidatePINEGK(UValidatePINEGK inmsg)
			throws java.lang.Exception {
		Secret pin = inmsg.getPin();
		if ((zustand == ZustandLeistungserbringerPC.IDLE && authBeide)) {
			setZustand(ZustandLeistungserbringerPC.WNONCEEGKpin);
			setPinegk(pin);
			sendMsg(new ErfrageNonceEGKpin(),
					Ports.ApothekenPC2Gesundheitskarte_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeNonceEGKpin(SendeNonceEGKpin inmsg)
			throws java.lang.Exception {
		Nonce n = inmsg.getN();
		if (zustand == ZustandLeistungserbringerPC.WNONCEEGKpin) {
			setNonce(n);
			PINData pindata = new PINData(pinegk, n);
			EncDataAsymm eds = EncDataAsymm.encrypt(zertPatient.getData()
					.getPubkey(), pindata);
			setZustand(ZustandLeistungserbringerPC.WBESTEGKPIN);
			sendMsg(new SendePINEGK(eds),
					Ports.ApothekenPC2Gesundheitskarte_default);
		} else {
			ABORTPC();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processBestaetigePINEGK(BestaetigePINEGK inmsg)
			throws java.lang.Exception {

		if (zustand == ZustandLeistungserbringerPC.WBESTEGKPIN) {
			setZustand(ZustandLeistungserbringerPC.IDLE);
			sendMsg(new UBestaetigePINEGK());
		} else {
			ABORTPC();
			stop();
		}
	}

	private void ABORTPC() throws TerminalException {
		setZustand(ZustandLeistungserbringerPC.IDLE);
		setAuthBeide(false);
		setSchluesselAusgetauscht(false);
		stop();
	}

	public byte getZustand() {
		return zustand;
	}

	public Nonce getNonce() {
		return nonce;
	}

	public ZertifikatLeistungserbringer getZertLeistungserbringer() {
		return zertLeistungserbringer;
	}

	public ZertifikatTrustedThirdParty getZertTTP() {
		return zertTTP;
	}

	public ZertifikatPatient getZertPatient() {
		return zertPatient;
	}

	public SymmKey getSessionkey() {
		return sessionkey;
	}

	public Secret getPinegk() {
		return pinegk;
	}

	public Secret getPinhba() {
		return pinhba;
	}

	public int getIdLeistungserbringerPC() {
		return idLeistungserbringerPC;
	}

	public boolean getAuthBeide() {
		return authBeide;
	}

	public boolean getSchluesselAusgetauscht() {
		return schluesselAusgetauscht;
	}

	public int getIndex() {
		return index;
	}

	public ListOfERezeptdaten getEingeloest() {
		return eingeloest;
	}

	public void setZustand(byte zustand) {
		this.zustand = zustand;
	}

	public void setNonce(Nonce nonce) {
		this.nonce = nonce;
	}
	public void setZertLeistungserbringer(
			ZertifikatLeistungserbringer zertLeistungserbringer) {
		this.zertLeistungserbringer = zertLeistungserbringer;
	}
	public void setZertTTP(ZertifikatTrustedThirdParty zertTTP) {
		this.zertTTP = zertTTP;
	}
	public void setZertPatient(ZertifikatPatient zertPatient) {
		this.zertPatient = zertPatient;
	}
	public void setSessionkey(SymmKey sessionkey) {
		this.sessionkey = sessionkey;
	}
	public void setPinegk(Secret pinegk) {
		this.pinegk = pinegk;
	}
	public void setPinhba(Secret pinhba) {
		this.pinhba = pinhba;
	}
	public void setIdLeistungserbringerPC(int idLeistungserbringerPC) {
		this.idLeistungserbringerPC = idLeistungserbringerPC;
	}

	public void setAuthBeide(boolean authBeide) {
		this.authBeide = authBeide;
	}

	public void setSchluesselAusgetauscht(boolean schluesselAusgetauscht) {
		this.schluesselAusgetauscht = schluesselAusgetauscht;
	}

	public void setIndex(int index) {
		this.index = index;
	}

	public void setEingeloest(ListOfERezeptdaten eingeloest) {
		this.eingeloest = eingeloest;
	}

	protected void stop() throws TerminalException {
		currentGate.callConstraints();
		throw new TerminalException("ApothekenPC");
	}

}
