package generated.eGKmitServices.terminal.apothekenPC;

import java.security.*;
import java.security.spec.*;

import javax.crypto.*;
import javax.crypto.spec.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;
@XmlAccessorType(XmlAccessType.FIELD)
public class EncDataSymm extends EncData {

	private final static String cryptProvider = "BC";
	private final static byte[] iv = {0, 0, 0, 0, 0, 0, 0, 0};
	@XmlTransient
	private final static AlgorithmParameterSpec paramSpec = new IvParameterSpec(
			iv);

	public EncDataSymm() {

		encrypted = new byte[LengthConstants.MAXENCRYPTLENGTHSYMM];

		tmparray = new byte[LengthConstants.MAXENCRYPTLENGTHSYMM];

		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());

	}

	public byte getCode() {
		return Code.ENCDATASYMM;
	}

	public boolean isEncDataSymm() {
		return true;
	}

	// ********************************************************
	public static EncDataSymm encrypt(SymmKey key, PlainData d)
			throws Exception {

		return (new EncDataSymm()).instEncrypt(key, d);

	}

	public EncDataSymm instEncrypt(SymmKey key, PlainData d) throws Exception {
		plainDataType = d.getCode();

		java.util.Arrays.fill(tmparray, (byte) 0);

		Coding.getInstance().encode(d, tmparray);

		plainlength = Coding.getInstance().getEncodingLength();
		enclength = plainlength % 8 == 0
				? plainlength
				: (short) (8 + plainlength - plainlength % 8);

		c = Cipher.getInstance("DESede/CBC/NoPadding", cryptProvider);
		c.init(Cipher.ENCRYPT_MODE, key.toAPIKey(), paramSpec);
		c.doFinal(tmparray, 0, enclength, encrypted, 0);

		return this;
	}

	private boolean check() {
		if (!(0 < plainlength && plainlength <= enclength && enclength <= encrypted.length))
			return false;
		return enclength % 8 == 0;
	}

	public static PlainData decrypt(SymmKey key, EncDataSymm e)
			throws Exception {
		return e.decrypt(key);
	}

	public PlainData decrypt(SymmKey key) throws Exception {
		if (!check())

			stop();

		c = Cipher.getInstance("DESede/CBC/NoPadding", cryptProvider);

		c.init(Cipher.DECRYPT_MODE, key.toAPIKey(), paramSpec);
		c.doFinal(encrypted, 0, enclength, tmparray, 0);

		return Coding.getInstance().decodePlainData(tmparray, plainDataType);
	}

	private void stop() throws TerminalException {
		throw new TerminalException("EncDataSymm");
	}

	public EncDataSymm copy() {
		EncDataSymm object = new EncDataSymm();
		object.copy(this);
		return object;
	}

}
