package generated.eGKmitServices.terminal.arztPC;
import java.io.*;
import java.lang.reflect.Method;
import java.util.*;
import javax.net.ssl.SSLSession;

import generated.eGKmitServices.server.krankenkasse.Krankenkasse;

public class StubsGenerator {
	public static void main(String[] s) {
		generateAllStubs();
	}
	public static void generateAllStubs() {
		try {

			Krankenkasse krankenkasse = new Krankenkasse();
			krankenkasse.startService();

			generateStubs("http://localhost:8000/KrankenkasseService?wsdl",
					"krankenkasse", false);

			krankenkasse.stopService();

		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	public static void generateStubs(String serviceWSDLAddress,
			String serverName, Boolean TLS) {

		String modelName = "eGKmitServices";
		String terminalName = "arztPC";
		Boolean isTerminalServer = false;

		System.out.println("generateStubs in: " + modelName + "/"
				+ terminalName + "/" + serverName);
		String terminalServerPackage;
		if (isTerminalServer)
			terminalServerPackage = "server";
		else
			terminalServerPackage = "terminal";

		String terminalPath = "../Generated/src/generated/" + modelName + "/"
				+ terminalServerPackage + "/" + terminalName;
		String stubsPath = "../Generated/src/generated/" + modelName + "/"
				+ terminalServerPackage + "/" + terminalName + "/" + serverName
				+ "Stubs";
		String serverClassName = serverName.substring(0, 1).toUpperCase()
				+ serverName.substring(1, serverName.length());

		//wenn statefulManager dann befindet er sich im package des servers zu dem er gehrt
		String serverPackageName;
		if (serverName.endsWith("StatefulManager"))
			serverPackageName = serverName.replaceAll("StatefulManager", "");
		else
			serverPackageName = serverName;

		try {
			System.out.println("compile server " + modelName + " package");
			System.out.println("startGenerateStubsInJava");

			if (TLS) {
				System.setProperty("javax.net.ssl.trustStore",
						"../Generated/src/META-INF/client-truststore.jks");
				System.setProperty("javax.net.ssl.trustStorePassword",
						"changeit");
				System.setProperty("javax.net.debug", "all");
				System.setProperty("javax.net.ssl.keyStore",
						"../Generated/src/META-INF/client-keystore.jks");
				System.setProperty("javax.net.ssl.keyStorePassword", "changeit");

				//Please remember to remove this once you install valid certificates on the server.        
				javax.net.ssl.HttpsURLConnection
						.setDefaultHostnameVerifier(new javax.net.ssl.HostnameVerifier() {
							@Override
							public boolean verify(String hostname,
									SSLSession arg1) {
								if (hostname.equals("localhost")) {
									return true;
								}
								return false;
							}
						});
			}

			String[] a = {
					"-keep",
					"-d",
					"../Generated/src",
					"-p",
					"generated." + modelName + "." + terminalServerPackage
							+ "." + terminalName + "." + serverName + "Stubs",
					serviceWSDLAddress};
			try {
				com.sun.tools.ws.WsImport.doMain(a);
			} catch (Throwable e) {
				e.printStackTrace();
			}

			System.out.println("delete Messages");

			List<File> stubFiles = getAllFilesWithSubDir(new File(stubsPath));
			List<File> terminalFiles = getAllFilesWithoutSubDir(new File(
					terminalPath));

			for (int i = 0; i < stubFiles.size(); i++) {
				for (int j = 0; j < terminalFiles.size(); j++) {
					if (terminalFiles.get(j).getName()
							.equals(stubFiles.get(i).getName())
							&& !terminalFiles.get(j).getName()
									.equals("ArztPC.java")
							&& !terminalFiles.get(j).getName()
									.equals("ArztPCStatefulManager.java")
							&& !terminalFiles.get(j).getName()
									.endsWith("Exception.java")) {
						System.out.println(stubFiles.get(i).getName());
						stubFiles.get(i).delete();
					}
				}
			}

			System.out.println("add Import Terminal in Stubs");
			stubFiles = getAllFilesWithSubDir(new File(stubsPath));
			for (int i = 0; i < stubFiles.size(); i++)
				addImport(stubFiles.get(i), "import generated." + modelName
						+ "." + terminalServerPackage + "." + terminalName
						+ ".*;");

		} catch (Exception ex) {
			System.out.println("exception " + ex.getMessage());
		}

	}

	public static List<File> getAllFilesWithSubDir(File path) {
		List<File> ret = new ArrayList<File>();
		File[] files = path.listFiles();
		for (File f : files) {
			if (f.isDirectory()) {
				ret.addAll(getAllFilesWithSubDir(f));
			} else {
				if (f.getName().endsWith(".java")) {
					ret.add(f);
				}
			}
		}
		return ret;
	}

	public static List<File> getAllFilesWithoutSubDir(File path) {
		List<File> ret = new ArrayList<File>();
		File[] files = path.listFiles();
		for (File f : files) {
			if (f.getName().endsWith(".java")) {
				ret.add(f);
			}
		}
		return ret;
	}

	public static void addImport(File file, String sImport) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(
				file.getPath()));
		Vector<String> list = new Vector<String>();
		String s;
		while ((s = reader.readLine()) != null) {
			list.add(s);
			if (s.contains("package"))
				list.add(sImport);
		}
		reader.close();
		BufferedWriter writer = new BufferedWriter(new FileWriter(
				file.getPath()));
		for (int i = 0; i < list.size(); i++) {
			writer.write(list.get(i));
			writer.write("\n");
		}
		writer.close();
	}

}
