package generated.eGKmitServices.terminal.arztPC;

import java.security.spec.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.DESedeKeySpec;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;
@XmlAccessorType(XmlAccessType.FIELD)
public class SymmKey extends Key implements Codeable, PlainData, SignData {

	public final static short SYMMKEYLENGTH = 24;

	public final static String cryptProvider = "BC";
	@XmlTransient
	private SecureRandom rand;

	private final static byte[] defaultSymmKey = new byte[]{(byte) 0x5A,
			(byte) 0x02, (byte) 0xCC, (byte) 0x1A, (byte) 0xC4, (byte) 0x71,
			(byte) 0x1C, (byte) 0x06, (byte) 0x3D, (byte) 0x49, (byte) 0x71,
			(byte) 0x61, (byte) 0x6B, (byte) 0x8C, (byte) 0x6A, (byte) 0x8E,
			(byte) 0xD9, (byte) 0x9E, (byte) 0x18, (byte) 0x55, (byte) 0xD7,
			(byte) 0x9F, (byte) 0xA7, (byte) 0xE4};

	private byte[] key;

	public SymmKey() {

		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());
		rand = new SecureRandom();

		key = defaultSymmKey;

	}

	public SymmKey(byte[] k) throws InvalidKeyException,
			InvalidKeySpecException, NoSuchAlgorithmException,
			NoSuchProviderException {
		this();
		setKey(k);

	}

	public static SymmKey generateKey() throws InvalidKeyException,
			InvalidKeySpecException, NoSuchAlgorithmException,
			NoSuchProviderException {

		return (new SymmKey()).instGenerateKey();

	}

	public static SymmKey generateKeyFromSecret(Secret s)
			throws InvalidKeyException, InvalidKeySpecException,
			NoSuchAlgorithmException, NoSuchProviderException {

		return Utils.instGenerateKey(new SymmKey(), s);

	}

	public SymmKey instGenerateKey() throws InvalidKeyException,
			InvalidKeySpecException, NoSuchAlgorithmException,
			NoSuchProviderException {

		byte[] k = new byte[SYMMKEYLENGTH];
		rand.nextBytes(k);
		setKey(k);
		return this;
	}

	public boolean equals(SymmKey other) {
		return Arrays.equals(key, other.key);
	}

	public byte getCode() {
		return Code.SYMMKEY;
	}

	public void setKey(byte[] k) throws InvalidKeyException,
			InvalidKeySpecException, NoSuchAlgorithmException,
			NoSuchProviderException {
		key = k.clone();
	}

	public void copy(SymmKey s) {

		if (s.getKey() != null) {
			try {
				setKey(s.key);
			} catch (InvalidKeyException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InvalidKeySpecException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchAlgorithmException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	public boolean isSymmKey() {
		return true;
	}

	public SecretKey toAPIKey() throws Exception {
		SecretKeyFactory kf = SecretKeyFactory.getInstance("DESede",
				cryptProvider);
		SecretKey apikey = kf.generateSecret(new DESedeKeySpec(key));
		return apikey;
	}

	public byte[] getKey() {
		return key;
	}
}
