package generated.eGKmitServices.javacard.gesundheitskarte;

import swt.util.HexString;
import javacard.framework.*;

/**
 * Generated Smartcard for EGKmitServices model
 */
public class Gesundheitskarte extends SimpleComm {

	public Secret pin;
	public PrivateKey privkeyEGK;
	public Nonce nonce;
	public SymmKey sessionkey;
	public boolean authHBA;
	public boolean pineingegeben;
	public boolean schluesselAusgetauscht;
	public boolean authKiosk;
	public ZertifikatKiosk zertKiosk;
	public PublicKey providerKey;
	public ZertifikatTrustedThirdParty zertTTP;
	public byte zustand;
	public ZertifikatPatient zert;
	public Versichertenstammdaten daten;
	public ListOfERezept rezepte;
	public ZertifikatLeistungserbringer zertLeistungserbringer;
	public Notfalldaten notfalldaten;
	public SignedData sigdaten;

	/**
	 * Constructor
	 */
	public Gesundheitskarte() {
		pin = new Secret();
		privkeyEGK = new PrivateKey();
		nonce = new Nonce();
		sessionkey = new SymmKey();
		authHBA = false;
		pineingegeben = false;
		schluesselAusgetauscht = false;
		authKiosk = false;
		zertKiosk = new ZertifikatKiosk();
		providerKey = new PublicKey();
		zertTTP = new ZertifikatTrustedThirdParty();
		zustand = ZustandEGK.APPLET_UNINITIALIZED;
		zert = new ZertifikatPatient();
		daten = new Versichertenstammdaten();
		rezepte = new ListOfERezept((short) 5);
		zertLeistungserbringer = new ZertifikatLeistungserbringer();
		notfalldaten = new Notfalldaten();
		sigdaten = new SignedData();
	}

	public void appletInitialization(byte[] buf, short offset) {
		if (zustand != ZustandEGK.APPLET_UNINITIALIZED)
			stop();
		Coding.getInstance().decodeGesundheitskarte(buf, offset, this);
	}

	/**
	 * This init method is used for testcases to quickly initialize a card
	 */
	public Gesundheitskarte init(Versichertenstammdaten daten, Secret pin,
			PrivateKey privkeyEGK, PublicKey providerKey, SignedData sigdaten,
			ZertifikatPatient zert, ZertifikatTrustedThirdParty zertTTP,
			byte zustand) {

		this.daten = daten;
		this.pin = pin;
		this.privkeyEGK = privkeyEGK;
		this.providerKey = providerKey;
		this.sigdaten = sigdaten;
		this.zert = zert;
		this.zertTTP = zertTTP;
		this.zustand = zustand;

		nonce = new Nonce();
		sessionkey = new SymmKey();
		authHBA = false;
		pineingegeben = false;
		schluesselAusgetauscht = false;
		authKiosk = false;
		zertKiosk = new ZertifikatKiosk();
		rezepte = new ListOfERezept((short) 5);
		zertLeistungserbringer = new ZertifikatLeistungserbringer();
		notfalldaten = new Notfalldaten();

		return this;
	}

	public Gesundheitskarte init() {
		pin = new Secret();
		privkeyEGK = new PrivateKey();
		nonce = new Nonce();
		sessionkey = new SymmKey();
		authHBA = false;
		pineingegeben = false;
		schluesselAusgetauscht = false;
		authKiosk = false;
		zertKiosk = new ZertifikatKiosk();
		providerKey = new PublicKey();
		zertTTP = new ZertifikatTrustedThirdParty();
		zustand = ZustandEGK.IDLEEGK;
		zert = new ZertifikatPatient();
		daten = new Versichertenstammdaten();
		rezepte = new ListOfERezept((short) 5);
		zertLeistungserbringer = new ZertifikatLeistungserbringer();
		notfalldaten = new Notfalldaten();
		sigdaten = new SignedData();

		return this;
	}

	/**
	 * process-method, is called from SimpleComm when a message arrives
	 * 
	 * @param inmsg message to process
	 */
	public void process(Message inmsg) {
		if (zustand == ZustandEGK.APPLET_UNINITIALIZED)
			stop();

		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.ERFRAGENONCEEGKPIN :
				processErfrageNonceEGKpin((ErfrageNonceEGKpin) inmsg);
				break;
			case Code.SENDEPINEGK :
				processSendePINEGK((SendePINEGK) inmsg);
				break;
			case Code.ERFRAGENONCEREZEPT :
				processErfrageNonceRezept((ErfrageNonceRezept) inmsg);
				break;
			case Code.SENDEREZEPT :
				processSendeRezept((SendeRezept) inmsg);
				break;
			case Code.ERFRAGENONCENOTFALLDATENERSTELLEN :
				processErfrageNonceNotfalldatenErstellen((ErfrageNonceNotfalldatenErstellen) inmsg);
				break;
			case Code.SENDENOTFALLDATENUNDSIG :
				processSendeNotfalldatenUndSig((SendeNotfalldatenUndSig) inmsg);
				break;
			case Code.ERFRAGENONCENOTFALLDATENLOESCHEN :
				processErfrageNonceNotfalldatenLoeschen((ErfrageNonceNotfalldatenLoeschen) inmsg);
				break;
			case Code.LOESCHENOTFALLDATEN :
				processLoescheNotfalldaten((LoescheNotfalldaten) inmsg);
				break;
			case Code.ERFRAGENOTFALLDATEN :
				processErfrageNotfalldaten((ErfrageNotfalldaten) inmsg);
				break;
			case Code.ERFRAGENONCEFUEREINLOESEN :
				processErfrageNonceFuerEinloesen((ErfrageNonceFuerEinloesen) inmsg);
				break;
			case Code.EINLOESEN :
				processEinloesen((Einloesen) inmsg);
				break;
			case Code.LESESTAMMUNDNOTFALLDATEN :
				processLeseStammUndNotfalldaten((LeseStammUndNotfalldaten) inmsg);
				break;
			case Code.SENDEZERTKIOSK :
				processSendeZertKiosk((SendeZertKiosk) inmsg);
				break;
			case Code.SENDENONCES :
				processSendeNonces((SendeNonces) inmsg);
				break;
			case Code.ERFRAGENONCEPIN :
				processErfrageNoncePIN((ErfrageNoncePIN) inmsg);
				break;
			case Code.SENDEPIN :
				processSendePIN((SendePIN) inmsg);
				break;
			case Code.ERFRAGENONCESCHLUESSELAUSTAUSCH :
				processErfrageNonceSchluesselaustausch((ErfrageNonceSchluesselaustausch) inmsg);
				break;
			case Code.SENDESESSIONKEYKIOSK :
				processSendeSessionkeyKiosk((SendeSessionkeyKiosk) inmsg);
				break;
			case Code.LESEREZEPT :
				processLeseRezept((LeseRezept) inmsg);
				break;
			case Code.GETDATA :
				processGetData((GetData) inmsg);
				break;
			case Code.UPDATE :
				processUpdate((Update) inmsg);
				break;
			case Code.AUTHENTISIEREEGK :
				processAuthentisiereEGK((AuthentisiereEGK) inmsg);
				break;
			case Code.SENDECHALLENGEEGKWEITER :
				processSendeChallengeEGKWeiter((SendeChallengeEGKWeiter) inmsg);
				break;
			case Code.SENDEZERTIFIKATHBA :
				processSendeZertifikatHBA((SendeZertifikatHBA) inmsg);
				break;
			case Code.ERFRAGENONCEEGKWEITER :
				processErfrageNonceEGKWeiter((ErfrageNonceEGKWeiter) inmsg);
				break;
			case Code.SENDESESSIONKEYWEITER :
				processSendeSessionkeyWeiter((SendeSessionkeyWeiter) inmsg);
				break;
			//Unknown Message
			default :
				stop();
		}

		currentGate.callConstraints();
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceEGKpin(ErfrageNonceEGKpin inmsg) {

		if (zustand == ZustandEGK.IDLEEGK) {
			nonce.copy(Nonce.generateNonce());
			zustand = ZustandEGK.WPINEGK;
			sendMsg(Store.newSendeNonceEGKpin(nonce));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendePINEGK(SendePINEGK inmsg) {
		EncDataAsymm ed = inmsg.ed;
		if (zustand == ZustandEGK.WPINEGK) {
			PINData pindata = (PINData) (EncDataAsymm.decrypt(privkeyEGK, ed));
			if ((pin.equals(pindata.pin) && nonce.equals(pindata.n))) {
				zustand = ZustandEGK.IDLEEGK;
				pineingegeben = true;
				sendMsg(Store.newBestaetigePINEGK());
			} else {
				ABORTEGK();
				stop();
			}
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceRezept(ErfrageNonceRezept inmsg) {

		if (((zustand == ZustandEGK.IDLEEGK && rezepte.hasFree()) && schluesselAusgetauscht)) {
			nonce.copy(Nonce.generateNonce());
			EGKDaten egkdaten = Store.newEGKDaten(nonce, daten);
			EncDataSymm ed = EncDataSymm.encrypt(sessionkey, egkdaten);
			zustand = ZustandEGK.REZEPTAUSSTELLENEGKA;
			sendMsg(Store.newSendeNonceRezept(ed));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeRezept(SendeRezept inmsg) {
		EncDataSymm ed = inmsg.ed;
		SignedData sig = inmsg.sig;
		if (zustand == ZustandEGK.REZEPTAUSSTELLENEGKA) {
			ERezeptdaten rezeptdaten = (ERezeptdaten) (EncDataSymm.decrypt(
					sessionkey, ed));
			if ((rezeptdaten.nonce.equals(nonce) && SignedData.verify(
					zertLeistungserbringer.data.pubkey, sig, rezeptdaten))) {
				ERezept rezept = Store.newERezept(rezeptdaten, sig,
						zertLeistungserbringer);
				rezepte.add(rezept);
				zustand = ZustandEGK.IDLEEGK;
				sendMsg(Store.newBestaetigeRezeptAusstellen());
			} else {
				ABORTEGK();
				stop();
			}
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceNotfalldatenErstellen(
			ErfrageNonceNotfalldatenErstellen inmsg) {

		if (((zustand == ZustandEGK.IDLEEGK && pineingegeben) && schluesselAusgetauscht)) {
			nonce.copy(Nonce.generateNonce());
			NonceData nd = Store.newNonceData(nonce);
			EncDataSymm ed = EncDataSymm.encrypt(sessionkey, nd);
			zustand = ZustandEGK.NOTFALLDATENEGKA;
			sendMsg(Store.newSendeNonceNotfalldatenErstellen(ed));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeNotfalldatenUndSig(SendeNotfalldatenUndSig inmsg) {
		EncDataSymm eds = inmsg.nfd;
		SignedData sig = inmsg.sig;
		if (zustand == ZustandEGK.NOTFALLDATENEGKA) {
			Notfalldaten tmp = (Notfalldaten) (EncDataSymm.decrypt(sessionkey,
					eds));
			if ((tmp.nonce.equals(nonce) && SignedData.verify(
					zertLeistungserbringer.data.pubkey, sig, tmp))) {
				notfalldaten.copy(tmp);
				zustand = ZustandEGK.IDLEEGK;
				sendMsg(Store.newBestaetigeNotfalldatenErstellen());
			} else {
				ABORTEGK();
				stop();
			}
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceNotfalldatenLoeschen(
			ErfrageNonceNotfalldatenLoeschen inmsg) {

		if ((((zustand == ZustandEGK.IDLEEGK && pineingegeben) && authKiosk) && schluesselAusgetauscht)) {
			zustand = ZustandEGK.LOESCHENOTFALLDATENEGKA;
			nonce.copy(Nonce.generateNonce());
			sendMsg(Store.newSendeNonce(nonce));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processLoescheNotfalldaten(LoescheNotfalldaten inmsg) {
		EncDataSymm ed = inmsg.nsd;
		NonceStringData nsd = (NonceStringData) (EncDataSymm.decrypt(
				sessionkey, ed));
		if ((zustand == ZustandEGK.LOESCHENOTFALLDATENEGKA && nsd.nonce
				.equals(nonce))) {
			Arrays.copy(nsd.s, notfalldaten.daten);
			notfalldaten.nonce.copy(Nonce.generateNonce());
			zustand = ZustandEGK.IDLEEGK;
			sendMsg(Store.newBestaetigeLoeschenNotfalldaten());
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNotfalldaten(ErfrageNotfalldaten inmsg) {
		Nonce no = inmsg.nonce;
		if ((((zustand == ZustandEGK.IDLEEGK && schluesselAusgetauscht) && zertLeistungserbringer.data.id == Constants.idArzt) && authHBA)) {
			NotfalldatenNonce nfdnonce = Store.newNotfalldatenNonce(no,
					notfalldaten.daten);
			EncDataSymm eds = EncDataSymm.encrypt(sessionkey, nfdnonce);
			sendMsg(Store.newSchickeNotfalldaten(eds));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceFuerEinloesen(ErfrageNonceFuerEinloesen inmsg) {

		if (((zustand == ZustandEGK.IDLEEGK && pineingegeben) && schluesselAusgetauscht)) {
			nonce.copy(Nonce.generateNonce());
			zustand = ZustandEGK.WARTEAUFINDEX;
			sendMsg(Store.newSendeNonceFuerEinloesen(nonce));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processEinloesen(Einloesen inmsg) {
		EncDataSymm enc = inmsg.in;
		IndexNonce id = (IndexNonce) (EncDataSymm.decrypt(sessionkey, enc));
		if (((zustand == ZustandEGK.WARTEAUFINDEX && nonce.equals(id.nonce)) && (id.index < rezepte
				.size()))) {
			ERezept rezept = Store.newERezept();

			rezept.copy(rezepte.at(id.index));;
			rezepte.remove(rezept);
			RezeptdatenUndNonce rdNonce = Store.newRezeptdatenUndNonce(
					id.nonceApothekenPC, rezept.rezeptdaten);
			EncDataSymm eds = EncDataSymm.encrypt(sessionkey, rdNonce);
			zustand = ZustandEGK.IDLEEGK;
			sendMsg(Store.newSendeRezeptZumEinloesen(eds, rezept.sig,
					rezept.zertifikatAusstellenderArzt));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processLeseStammUndNotfalldaten(LeseStammUndNotfalldaten inmsg) {
		EncDataSymm ed = inmsg.nd;
		if ((((zustand == ZustandEGK.IDLEEGK && pineingegeben) && authKiosk) && schluesselAusgetauscht)) {
			NonceData nd = (NonceData) (EncDataSymm.decrypt(sessionkey, ed));
			short num = rezepte.size();
			StammUndNotfalldaten sd = Store.newStammUndNotfalldaten(
					notfalldaten.daten, nd.nonce, num, daten);
			EncDataSymm eds = EncDataSymm.encrypt(sessionkey, sd);
			sendMsg(Store.newSendeStammUndNotfalldaten(eds));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeZertKiosk(SendeZertKiosk inmsg) {
		ZertifikatKiosk z = inmsg.zertKiosk;
		if (((zustand == ZustandEGK.IDLEEGK && z
				.verifyCertificate(zertTTP.data.pubkey)) && z.data.id == Constants.idKiosk)) {
			zertKiosk.copy(z);
			nonce.copy(Nonce.generateNonce());
			NonceData nd = Store.newNonceData(nonce);
			EncDataAsymm ed = EncDataAsymm.encrypt(z.data.pubkey, nd);
			zustand = ZustandEGK.AUTHKIOSKEGKA;
			sendMsg(Store.newSendeZertEGK(ed, zert));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeNonces(SendeNonces inmsg) {
		Nonce n = inmsg.nonce;
		EncDataAsymm ed = inmsg.nd;
		if ((zustand == ZustandEGK.AUTHKIOSKEGKA && n.equals(nonce))) {
			NonceData nd = (NonceData) (EncDataAsymm.decrypt(privkeyEGK, ed));
			authKiosk = true;
			zustand = ZustandEGK.IDLEEGK;
			sendMsg(Store.newBestaetigeNonce(nd.nonce));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNoncePIN(ErfrageNoncePIN inmsg) {

		if ((zustand == ZustandEGK.IDLEEGK && authKiosk)) {
			nonce.copy(Nonce.generateNonce());
			zustand = ZustandEGK.PINEGKA;
			sendMsg(Store.newSendeNoncePIN(nonce));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendePIN(SendePIN inmsg) {
		EncDataAsymm eds = inmsg.pindata;
		PINData pindata = (PINData) (EncDataAsymm.decrypt(privkeyEGK, eds));
		if (((zustand == ZustandEGK.PINEGKA && pin.equals(pindata.pin)) && nonce
				.equals(pindata.n))) {
			zustand = ZustandEGK.IDLEEGK;
			pineingegeben = true;
			sendMsg(Store.newBestaetigePIN());
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceSchluesselaustausch(
			ErfrageNonceSchluesselaustausch inmsg) {

		if ((zustand == ZustandEGK.IDLEEGK && authKiosk)) {
			nonce.copy(Nonce.generateNonce());
			NonceData nd = Store.newNonceData(nonce);
			EncDataAsymm ed = EncDataAsymm.encrypt(zertKiosk.data.pubkey, nd);
			zustand = ZustandEGK.SCHLUESSELKIOSKEGK;
			sendMsg(Store.newSendeNonceSchluesselaustausch(ed));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeSessionkeyKiosk(SendeSessionkeyKiosk inmsg) {
		EncDataAsymm eds = inmsg.kd;
		KeyData kd = (KeyData) (EncDataAsymm.decrypt(privkeyEGK, eds));
		if ((zustand == ZustandEGK.SCHLUESSELKIOSKEGK && kd.nonce.equals(nonce))) {
			sessionkey.copy(kd.sessionkey);
			zustand = ZustandEGK.IDLEEGK;
			schluesselAusgetauscht = true;
			sendMsg(Store.newSchluesselKioskOK());
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processLeseRezept(LeseRezept inmsg) {
		EncDataSymm eds = inmsg.ndi;
		NonceDataAndIndex nd = (NonceDataAndIndex) (EncDataSymm.decrypt(
				sessionkey, eds));
		if (((((zustand == ZustandEGK.IDLEEGK && pineingegeben) && authKiosk) && schluesselAusgetauscht) && (nd.index < rezepte
				.size()))) {
			NonceUndRezept nur = Store.newNonceUndRezept(nd.nonce,
					rezepte.at(nd.index).rezeptdaten);
			EncDataSymm ed = EncDataSymm.encrypt(sessionkey, nur);
			sendMsg(Store.newSendeRezeptdaten(ed));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processGetData(GetData inmsg) {

		if ((authHBA && pineingegeben)) {
			nonce.copy(Nonce.generateNonce());
			zustand = ZustandEGK.EXPUPDATE;
			System.out.println("Modulus pubKey: " +HexString.hexify(providerKey.modulus));
			EncDataAsymm ed = EncDataAsymm.encrypt(providerKey, daten);
			sendMsg(Store.newCardData(nonce, ed, sigdaten, zert));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processUpdate(Update inmsg) {
		EncDataAsymm eds = inmsg.daten;
		SignedData newsig = inmsg.sigdaten;
		SignedData sigWithNonce = inmsg.sigWithNonce;
		Versichertenstammdaten newvsd = (Versichertenstammdaten) (EncDataAsymm
				.decrypt(privkeyEGK, eds));
		if (zustand == ZustandEGK.EXPUPDATE) {
			zustand = ZustandEGK.IDLEEGK;
			UpdateAuth ua = Store.newUpdateAuth(nonce, daten);
			if ((SignedData.verify(providerKey, sigWithNonce, ua) && SignedData
					.verify(providerKey, newsig, newvsd))) {
				daten.copy(newvsd);
				sigdaten.copy(newsig);
				sendMsg(Store.newOK());
			} else {
				ABORTEGK();
				stop();
			}
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processAuthentisiereEGK(AuthentisiereEGK inmsg) {
		Nonce nonceHBA = inmsg.nonce;
		if (zustand == ZustandEGK.WNONCEHBA) {
			if (nonce.equals(nonceHBA)) {
				authHBA = true;
				zustand = ZustandEGK.WCHALLENGEAUTHEGK;
				sendMsg(Store.newRetAuthentisiereEGK(zert));
			} else {
				ABORTEGK();
				stop();
			}
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeChallengeEGKWeiter(SendeChallengeEGKWeiter inmsg) {
		EncDataAsymm encCard = inmsg.encCard;
		EncDataAsymm enc = inmsg.enc;
		if (zustand == ZustandEGK.WCHALLENGEAUTHEGK) {
			NonceData ndCard = (NonceData) (EncDataAsymm.decrypt(privkeyEGK,
					encCard));
			NonceData ndTerm = (NonceData) (EncDataAsymm.decrypt(privkeyEGK,
					enc));
			zustand = ZustandEGK.IDLEEGK;
			sendMsg(Store.newRetSendeChallengeEGK(ndCard.nonce, ndTerm.nonce));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeZertifikatHBA(SendeZertifikatHBA inmsg) {
		ZertifikatLeistungserbringer empfzert = inmsg.zertLeistungserbringer;
		if (zustand == ZustandEGK.IDLEEGK) {
			if (empfzert.verifyCertificate(zertTTP.data.pubkey)) {
				if ((empfzert.data.id == Constants.idArzt || empfzert.data.id == Constants.idApotheker)) {
					nonce.copy(Nonce.generateNonce());
					zertLeistungserbringer.copy(empfzert);
					NonceData nd = Store.newNonceData(nonce);
					EncDataAsymm enc = EncDataAsymm.encrypt(
							zertLeistungserbringer.data.pubkey, nd);
					zustand = ZustandEGK.WNONCEHBA;
					sendMsg(Store.newSendeChallengeHBA(enc));
				} else {
					ABORTEGK();
					stop();
				}
			} else {
				ABORTEGK();
				stop();
			}
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceEGKWeiter(ErfrageNonceEGKWeiter inmsg) {

		if ((zustand == ZustandEGK.IDLEEGK && authHBA)) {
			nonce.copy(Nonce.generateNonce());
			SecretNonceData nd = Store.newSecretNonceData(nonce);
			EncDataAsymm enc = EncDataAsymm.encrypt(
					zertLeistungserbringer.data.pubkey, nd);
			zustand = ZustandEGK.SCHLUESSELAUSTAUSCHEGKA;
			sendMsg(Store.newSendeNonceVerschluesseltEGK(enc));
		} else {
			ABORTEGK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeSessionkeyWeiter(SendeSessionkeyWeiter inmsg) {
		EncDataAsymm enc = inmsg.enc;
		KeyData kd = (KeyData) (EncDataAsymm.decrypt(privkeyEGK, enc));
		if ((zustand == ZustandEGK.SCHLUESSELAUSTAUSCHEGKA && nonce
				.equals(kd.nonce))) {
			sessionkey.copy(kd.sessionkey);
			schluesselAusgetauscht = true;
			zustand = ZustandEGK.IDLEEGK;
			sendMsg(Store.newBestaetigeSchluesselaustausch());
		} else {
			ABORTEGK();
			stop();
		}
	}

	private void ABORTEGK() throws ISOException {
		zustand = ZustandEGK.IDLEEGK;
		pineingegeben = false;
		authHBA = false;
		schluesselAusgetauscht = false;
		authKiosk = false;
		stop();
	}

}
