package generated.eGKmitServices.javacard.heilberufsausweisApotheker;

import javacard.framework.*;

/**
 * Generated Smartcard for EGKmitServices model
 */
public class HeilberufsausweisApotheker extends SimpleComm {

	public Secret pin;
	public ZertifikatTrustedThirdParty zertTTP;
	public byte zustand;
	public PrivateKey privkeyHBA;
	public Nonce nonce;
	public ZertifikatLeistungserbringer zert;
	public SymmKey sessionkey;
	public ListOfERezept rezepte;
	public ZertifikatPatient zertPatient;
	public boolean authEGK;
	public boolean pineingegeben;
	public boolean schluesselAusgetauscht;

	/**
	 * Constructor
	 */
	public HeilberufsausweisApotheker() {
		pin = new Secret();
		zertTTP = new ZertifikatTrustedThirdParty();
		zustand = ZustandHBA.APPLET_UNINITIALIZED;
		privkeyHBA = new PrivateKey();
		nonce = new Nonce();
		zert = new ZertifikatLeistungserbringer();
		sessionkey = new SymmKey();
		rezepte = new ListOfERezept((short) 5);
		zertPatient = new ZertifikatPatient();
		authEGK = false;
		pineingegeben = false;
		schluesselAusgetauscht = false;
	}

	public void appletInitialization(byte[] buf, short offset) {
		if (zustand != ZustandHBA.APPLET_UNINITIALIZED)
			stop();
		Coding.getInstance()
				.decodeHeilberufsausweisApotheker(buf, offset, this);
	}

	/**
	 * This init method is used for testcases to quickly initialize a card
	 */
	public HeilberufsausweisApotheker init(Secret pin, PrivateKey privkeyHBA,
			ZertifikatLeistungserbringer zert,
			ZertifikatTrustedThirdParty zertTTP, byte zustand) {

		this.pin = pin;
		this.privkeyHBA = privkeyHBA;
		this.zert = zert;
		this.zertTTP = zertTTP;
		this.zustand = zustand;

		nonce = new Nonce();
		sessionkey = new SymmKey();
		rezepte = new ListOfERezept((short) 5);
		zertPatient = new ZertifikatPatient();
		authEGK = false;
		pineingegeben = false;
		schluesselAusgetauscht = false;

		return this;
	}

	public HeilberufsausweisApotheker init() {
		pin = new Secret();
		zertTTP = new ZertifikatTrustedThirdParty();
		zustand = ZustandHBA.IDLEHBA;
		privkeyHBA = new PrivateKey();
		nonce = new Nonce();
		zert = new ZertifikatLeistungserbringer();
		sessionkey = new SymmKey();
		rezepte = new ListOfERezept((short) 5);
		zertPatient = new ZertifikatPatient();
		authEGK = false;
		pineingegeben = false;
		schluesselAusgetauscht = false;

		return this;
	}

	/**
	 * process-method, is called from SimpleComm when a message arrives
	 * 
	 * @param inmsg message to process
	 */
	public void process(Message inmsg) {
		if (zustand == ZustandHBA.APPLET_UNINITIALIZED)
			stop();

		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.AUTHENTISIEREHBA :
				processAuthentisiereHBA((AuthentisiereHBA) inmsg);
				break;
			case Code.SENDECHALLENGEHBAWEITER :
				processSendeChallengeHBAWeiter((SendeChallengeHBAWeiter) inmsg);
				break;
			case Code.RETAUTHENTISIEREEGKWEITER :
				processRetAuthentisiereEGKWeiter((RetAuthentisiereEGKWeiter) inmsg);
				break;
			case Code.RETSENDECHALLENGEEGKWEITER :
				processRetSendeChallengeEGKWeiter((RetSendeChallengeEGKWeiter) inmsg);
				break;
			case Code.ERFRAGENONCEHBA :
				processErfrageNonceHBA((ErfrageNonceHBA) inmsg);
				break;
			case Code.SENDESCHLUESSEL :
				processSendeSchluessel((SendeSchluessel) inmsg);
				break;
			case Code.SENDENONCEVERSCHLUESSELTEGKWEITER :
				processSendeNonceVerschluesseltEGKWeiter((SendeNonceVerschluesseltEGKWeiter) inmsg);
				break;
			case Code.ERFRAGENONCEHBAPIN :
				processErfrageNonceHBApin((ErfrageNonceHBApin) inmsg);
				break;
			case Code.SENDEPINHBA :
				processSendePINHBA((SendePINHBA) inmsg);
				break;
			//Unknown Message
			default :
				stop();
		}

		currentGate.callConstraints();
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processAuthentisiereHBA(AuthentisiereHBA inmsg) {

		if (zustand == ZustandHBA.IDLEHBA) {
			zustand = ZustandHBA.WCHALLENGEAUTH;
			sendMsg(Store.newRetAuthentisiereHBA(zert));
		} else {
			ABORTHBA();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeChallengeHBAWeiter(SendeChallengeHBAWeiter inmsg) {
		EncDataAsymm encCard = inmsg.encCard;
		EncDataAsymm enc = inmsg.enc;
		if (zustand == ZustandHBA.WCHALLENGEAUTH) {
			NonceData ndCard = (NonceData) (EncDataAsymm.decrypt(privkeyHBA,
					encCard));
			NonceData ndTerm = (NonceData) (EncDataAsymm.decrypt(privkeyHBA,
					enc));
			zustand = ZustandHBA.AUTHHBA;
			sendMsg(Store.newRetSendeChallengeHBA(ndCard.nonce, ndTerm.nonce));
		} else {
			ABORTHBA();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processRetAuthentisiereEGKWeiter(RetAuthentisiereEGKWeiter inmsg) {
		ZertifikatPatient empfzert = inmsg.zertPatient;
		if (zustand == ZustandHBA.AUTHHBA) {
			if (empfzert.verifyCertificate(zertTTP.data.pubkey)) {
				if (empfzert.data.id == Constants.idGesundheitskarte) {
					nonce.copy(Nonce.generateNonce());
					zertPatient.copy(empfzert);
					NonceData nd = Store.newNonceData(nonce);
					EncDataAsymm enc = EncDataAsymm.encrypt(
							zertPatient.data.pubkey, nd);
					zustand = ZustandHBA.WNONCEEGK;
					sendMsg(Store.newSendeChallengeEGK(enc));
				} else {
					ABORTHBA();
					stop();
				}
			} else {
				ABORTHBA();
				stop();
			}
		} else {
			ABORTHBA();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processRetSendeChallengeEGKWeiter(
			RetSendeChallengeEGKWeiter inmsg) {
		Nonce nonceEGK = inmsg.nonce;
		if (zustand == ZustandHBA.WNONCEEGK) {
			if (nonce.equals(nonceEGK)) {
				authEGK = true;
				zustand = ZustandHBA.IDLEHBA;
				sendMsg(Store.newEndAuth());
			} else {
				ABORTHBA();
				stop();
			}
		} else {
			ABORTHBA();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceHBA(ErfrageNonceHBA inmsg) {

		if ((zustand == ZustandHBA.IDLEHBA && pineingegeben == true)) {
			nonce.copy(Nonce.generateNonce());
			SecretNonceData nd = Store.newSecretNonceData(nonce);
			EncDataSymm enc = EncDataSymm.encrypt(
					SymmKey.generateKeyFromSecret(pin), nd);
			zustand = ZustandHBA.SCHLUESSELAUSTAUSCHHBAA;
			sendMsg(Store.newSendeNonceVerschluesseltHBA(enc));
		} else {
			ABORTHBA();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeSchluessel(SendeSchluessel inmsg) {
		EncDataAsymm enc = inmsg.enc;
		KeyData kd = (KeyData) (EncDataAsymm.decrypt(privkeyHBA, enc));
		if ((zustand == ZustandHBA.SCHLUESSELAUSTAUSCHHBAA && kd.nonce
				.equals(nonce))) {
			sessionkey.copy(kd.sessionkey);
			schluesselAusgetauscht = true;
			zustand = ZustandHBA.SCHLUESSELAUSTAUSCHHBAB;
			sendMsg(Store.newErfrageNonceEGK());
		} else {
			ABORTHBA();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendeNonceVerschluesseltEGKWeiter(
			SendeNonceVerschluesseltEGKWeiter inmsg) {
		EncDataAsymm enc = inmsg.enc;
		if ((zustand == ZustandHBA.SCHLUESSELAUSTAUSCHHBAB && authEGK)) {
			SecretNonceData nd = (SecretNonceData) (EncDataAsymm.decrypt(
					privkeyHBA, enc));
			nonce.copy(nd.nonce);
			KeyData kd = Store.newKeyData(nonce, sessionkey);
			EncDataAsymm encC = EncDataAsymm.encrypt(zertPatient.data.pubkey,
					kd);
			zustand = ZustandHBA.IDLEHBA;
			sendMsg(Store.newSendeSessionkey(encC));
		} else {
			ABORTHBA();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processErfrageNonceHBApin(ErfrageNonceHBApin inmsg) {

		if (zustand == ZustandHBA.IDLEHBA) {
			nonce.copy(Nonce.generateNonce());
			zustand = ZustandHBA.WPINHBA;
			sendMsg(Store.newSendeNonceHBApin(nonce));
		} else {
			ABORTHBA();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendePINHBA(SendePINHBA inmsg) {
		EncDataAsymm ed = inmsg.ed;
		if (zustand == ZustandHBA.WPINHBA) {
			PINData pindata = (PINData) (EncDataAsymm.decrypt(privkeyHBA, ed));
			if ((pin.equals(pindata.pin) && nonce.equals(pindata.n))) {
				zustand = ZustandHBA.IDLEHBA;
				pineingegeben = true;
				sendMsg(Store.newBestaetigePINHBA());
			} else {
				ABORTHBA();
				stop();
			}
		} else {
			ABORTHBA();
			stop();
		}
	}

	private void ABORTHBA() throws ISOException {
		zustand = ZustandHBA.IDLEHBA;
		pineingegeben = false;
		schluesselAusgetauscht = false;
		authEGK = false;
		stop();
	}

}
