package generated.eGKmitServices.javacard.heilberufsausweisArzt;

import javacard.security.DESKey;
import javacard.security.KeyBuilder;
import javacard.security.RandomData;

public class SymmKey extends Key implements Codeable, PlainData, SignData {

	public final static short SYMMKEYLENGTH = 24;

	private final static byte[] defaultSymmKey = new byte[]{(byte) 0x5A,
			(byte) 0x02, (byte) 0xCC, (byte) 0x1A, (byte) 0xC4, (byte) 0x71,
			(byte) 0x1C, (byte) 0x06, (byte) 0x3D, (byte) 0x49, (byte) 0x71,
			(byte) 0x61, (byte) 0x6B, (byte) 0x8C, (byte) 0x6A, (byte) 0x8E,
			(byte) 0xD9, (byte) 0x9E, (byte) 0x18, (byte) 0x55, (byte) 0xD7,
			(byte) 0x9F, (byte) 0xA7, (byte) 0xE4};

	private DESKey apikey;
	private static RandomData rd;

	public byte[] key;

	public SymmKey() {

		key = new byte[SYMMKEYLENGTH];
		apikey = (DESKey) KeyBuilder.buildKey(KeyBuilder.TYPE_DES,
				KeyBuilder.LENGTH_DES3_3KEY, false);
		Arrays.copy(defaultSymmKey, this.key);
		updateKey();

	}

	public SymmKey(byte[] key) {
		this();

		Arrays.copy(key, this.key);
		updateKey();

	}

	public static SymmKey generateKey() {

		if (rd == null)
			rd = RandomData.getInstance(RandomData.ALG_SECURE_RANDOM);
		return Store.newSymmKey().instGenerateKey();
	}

	public static SymmKey generateKeyFromSecret(Secret s) {

		return Utils.instGenerateKey(Store.newSymmKey(), s);
	}

	public SymmKey instGenerateKey() {

		rd.generateData(key, (short) 0, (short) SymmKey.SYMMKEYLENGTH);
		updateKey();

		return this;
	}

	public boolean equals(SymmKey other) {
		return Arrays.equals(key, other.key);
	}

	public byte getCode() {
		return Code.SYMMKEY;
	}

	public void updateKey() {
		apikey.setKey(key, (short) 0);
	}

	public void copy(SymmKey s) {

		Arrays.copy(s.key, key);
		apikey.setKey(key, (short) 0);

	}

	public boolean isSymmKey() {
		return true;
	}

	public javacard.security.Key toAPIKey() {
		return apikey;
	}

}
