package generated.eGKmitServices.terminal.kiosk;

//import swt.simulation.SmartCardSimulation;
import swt.terminal.HandleResult;
import swt.util.ByteArray;
import swt.util.HexString;
import de.uniaugsburg.swt.javacard.terminalinterface.SWTReader;
import de.uniaugsburg.swt.javacard.terminalinterface.SWTReaderException;
import javax.xml.ws.BindingProvider;

public class Kiosk {

	private boolean AuthEGK;

	private boolean schluesselAusgetauscht;

	private PrivateKey privkey;

	private ZertifikatPatient zertEGK;

	private Nonce nonce;

	private Secret pinegk;

	private SymmKey sessionkey;

	private ZertifikatTrustedThirdParty zertTTP;

	private ZertifikatKiosk zert;

	private byte zustand;

	private Userinterface userinterface;
	public void setUserinterface(Userinterface u) {
		this.userinterface = u;
	}

	// saved prev message
	public byte[] prevMsg;
	public Usermessage prevUMsg;

	public final Gate dummyGate = new Gate() {
		@Override
		public void callConstraints() {
			/* do nothing */
		}

		@Override
		public byte[] transmit(Kiosk terminal, byte[] apdu, int port)
				throws TerminalException, SWTReaderException {
			return terminal.transmit(apdu, port);
		}

		@Override
		public void finishProtocol(Kiosk terminal) {
			/* do nothing */
		}

	};
	public Gate currentGate = dummyGate;

	/**
	 * Resets the current gate to a default dummy gate
	 */
	public void resetGate() {
		currentGate = dummyGate;
	}

	/**
	 * Sets the current gate
	 */
	public void setGate(Gate gate) {
		currentGate = gate;
	}

	public Kiosk() throws java.lang.Exception {

		AuthEGK = false;
		schluesselAusgetauscht = false;
		privkey = new PrivateKey();
		zertEGK = new ZertifikatPatient();
		nonce = new Nonce();
		pinegk = new Secret();
		sessionkey = new SymmKey();
		zertTTP = new ZertifikatTrustedThirdParty();
		zert = new ZertifikatKiosk();
		zustand = ZustandKiosk.IDLEKIOSK;

	}

	public Kiosk(PrivateKey privkey, ZertifikatKiosk zert,
			ZertifikatTrustedThirdParty zertTTP, byte zustand)
			throws java.lang.Exception {

		this.privkey = privkey;
		this.zert = zert;
		this.zertTTP = zertTTP;
		this.zustand = zustand;

		AuthEGK = false;
		schluesselAusgetauscht = false;
		zertEGK = new ZertifikatPatient();
		nonce = new Nonce();
		pinegk = new Secret();
		sessionkey = new SymmKey();

	}

	private void sendMsg(Message msg) {

		currentGate.callConstraints();
		userinterface.send((Usermessage) msg);

	}

	private void sendMsg(Message msg, int port) throws java.lang.Exception {

		sendMsg(msg, port, false, false);

	}
	private void sendMsg(Message msg, int port, Boolean openSessionBeforeSend,
			Boolean closeSessionAfterReceive) throws java.lang.Exception {

		currentGate.callConstraints();

		Message response;

		switch (port) {
			case Ports.Kiosk2Gesundheitskarte_default :
				response = sendCardMsg(msg, port);
				if (response != null)
					processMessage(response);
				break;

			default :
				stop();
		}
	}

	private Message sendCardMsg(Message msg, int port)
			throws java.lang.Exception {
		byte[] encMsg = new byte[LengthConstants.MAX_ENCODING_LENGTH_MESSAGES];
		short encMsgLen = Coding.getInstance().encode((Codeable) msg, encMsg);
		encMsg = ByteArray.subarray(encMsg, 0, encMsgLen);
		byte[] apdu = ByteArray.append(new byte[]{0, 2, 0, 0, 0}, encMsg);
		byte[] response = currentGate.transmit(this, apdu, port);

		if (response.length == 2) {
			if (!(response[0] == (byte) 0x90 && response[1] == (byte) 0x00))
				throw new TerminalException("Cardexception: "
						+ HandleResult.interpretSW(response));
			return null;
		} else {
			prevMsg = response;

			Coding.getInstance().decodeInit();
			Codeable cResponse = Coding.getInstance().decode(response);
			return (Message) cResponse;
		}
	}

	/**
	 * Processes a raw data stream by trying to decode data to Message.
	 * Needed for testcases.
	 * @param data
	 */
	public void processRawMessage(byte[] data) {
		prevMsg = data;
		try {
			Coding.getInstance().decodeInit();
			Codeable cResponse = Coding.getInstance().decode(data);
			processMessage((Message) cResponse);
		} catch (java.lang.Exception e) {
			System.err.println("Failed decoding data in processRawMessage");
		}

	}

	private void processMessage(Message inmsg) throws java.lang.Exception {
		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.UNOTFALLDATENLOESCHEN :
				processUNotfalldatenLoeschen((UNotfalldatenLoeschen) inmsg);
				break;
			case Code.SENDENONCE :
				processSendeNonce((SendeNonce) inmsg);
				break;
			case Code.BESTAETIGELOESCHENNOTFALLDATEN :
				processBestaetigeLoeschenNotfalldaten((BestaetigeLoeschenNotfalldaten) inmsg);
				break;
			case Code.ULESESTAMMUNDNOTFALLDATEN :
				processULeseStammUndNotfalldaten((ULeseStammUndNotfalldaten) inmsg);
				break;
			case Code.SENDESTAMMUNDNOTFALLDATEN :
				processSendeStammUndNotfalldaten((SendeStammUndNotfalldaten) inmsg);
				break;
			case Code.UAUTHEGKUNDKIOSK :
				processUAuthEGKUndKiosk((UAuthEGKUndKiosk) inmsg);
				break;
			case Code.SENDEZERTEGK :
				processSendeZertEGK((SendeZertEGK) inmsg);
				break;
			case Code.BESTAETIGENONCE :
				processBestaetigeNonce((BestaetigeNonce) inmsg);
				break;
			case Code.UPINEINGABEKIOSK :
				processUPINEingabeKiosk((UPINEingabeKiosk) inmsg);
				break;
			case Code.SENDENONCEPIN :
				processSendeNoncePIN((SendeNoncePIN) inmsg);
				break;
			case Code.BESTAETIGEPIN :
				processBestaetigePIN((BestaetigePIN) inmsg);
				break;
			case Code.USCHLUESSELAUSTAUSCH :
				processUSchluesselaustausch((USchluesselaustausch) inmsg);
				break;
			case Code.SENDENONCESCHLUESSELAUSTAUSCH :
				processSendeNonceSchluesselaustausch((SendeNonceSchluesselaustausch) inmsg);
				break;
			case Code.SCHLUESSELKIOSKOK :
				processSchluesselKioskOK((SchluesselKioskOK) inmsg);
				break;
			case Code.ULESEREZEPT :
				processULeseRezept((ULeseRezept) inmsg);
				break;
			case Code.SENDEREZEPTDATEN :
				processSendeRezeptdaten((SendeRezeptdaten) inmsg);
				break;
			default :
				stop();
		}

		currentGate.callConstraints();
		currentGate.finishProtocol(this);
	}

	public void process(Message msg) throws TerminalException {
		currentGate.callConstraints();

		try {
			if (msg instanceof Usermessage)
				prevUMsg = (Usermessage) msg;
			processMessage(msg);
		} catch (java.lang.Exception e) {
			// e.printStackTrace();
			if (e instanceof TerminalException)
				throw (TerminalException) e;
			else
				throw new TerminalException(
						"Error when calling process method: " + e);
		}

		currentGate.callConstraints();
		currentGate.finishProtocol(this);
	}

	private final static int MAX_SPLIT_LENGTH = 50;
	private final static int MAX_APDU_LENGTH = 254;
	private final static int APDU_HEADER_LENGTH = 5;
	private final static int APDU_DATA_LENTH = MAX_APDU_LENGTH
			- APDU_HEADER_LENGTH;
	private SWTReader[] reader = new SWTReader[5];

	public void initReader(SWTReader reader, int port) {
		this.reader[port] = reader;
	}

	public byte[] encode(Codeable c) throws java.lang.Exception {
		byte[] encMsg = new byte[LengthConstants.MAX_ENCODING_LENGTH_MESSAGES];
		short encMsgLen = Coding.getInstance().encode(c, encMsg);
		return ByteArray.subarray(encMsg, 0, encMsgLen);
	}

	public byte[] transmit(byte[] apdu, int port) throws TerminalException,
			SWTReaderException {
		byte[] received = null;
		if (apdu.length <= MAX_APDU_LENGTH) {
			apdu[4] = (byte) (apdu.length - 5);
			received = reader[port].transmit(apdu);
			if (received.length == 2)
				return received;
			received = ByteArray.subarray(received, 0, received.length - 2);
		} else {
			byte[] splittedApdu;
			byte[] apduHeader = ByteArray.subarray(apdu, 0, APDU_HEADER_LENGTH);
			apdu = ByteArray.subarray(apdu, APDU_HEADER_LENGTH);
			int splitCount = apdu.length / APDU_DATA_LENTH;
			if (apdu.length % APDU_DATA_LENTH != 0)
				splitCount++;
			for (int i = 0; i < splitCount; i++) {
				if (i == splitCount - 1) {
					splittedApdu = ByteArray
							.subarray(apdu, i * APDU_DATA_LENTH);
					apduHeader[2] = (byte) 0;
					apduHeader[4] = (byte) splittedApdu.length;
					splittedApdu = ByteArray.append(apduHeader, splittedApdu);
					received = reader[port].transmit(splittedApdu);
					if (received.length == 2)
						return received;
					received = ByteArray.subarray(received, 0,
							received.length - 2);
				} else {
					splittedApdu = ByteArray.subarray(apdu,
							i * APDU_DATA_LENTH, APDU_DATA_LENTH);
					apduHeader[2] = (byte) 1;
					apduHeader[4] = (byte) splittedApdu.length;
					splittedApdu = ByteArray.append(apduHeader, splittedApdu);
					received = reader[port].transmit(splittedApdu);
					if (!(received[0] == (byte) 0x90 && received[1] == (byte) 0x00)) {
						throw new TerminalException(
								"Bad answer from card: part of a long APDU was not answered with OK (0x9000).");
					}
				}
			}
		}

		for (int i = 0; i < MAX_SPLIT_LENGTH; i++) {
			if (received[0] == 0) {
				received = ByteArray.subarray(received, 1);
				return received;
			} else if (received[0] == 1) {
				received = ByteArray.subarray(received, 1);
				byte[] getMore = new byte[]{0, 6, 0, 0, 0, 1, 1};
				byte[] temp_received = reader[port].transmit(getMore);

				temp_received = ByteArray.subarray(temp_received, 0,
						temp_received.length - 2);
				received = ByteArray.append(temp_received[0], received);
				temp_received = ByteArray.subarray(temp_received, 1);
				received = ByteArray.append(received, temp_received);
			} else
				throw new TerminalException(
						"Bad answer from card: answer to a long APDU must begin with 0 or 1.");
		}
		return received;
	}

	/**
	 * This method initializes the card with the given parameters that correspond 
	 * to the card attributes. A null value will be ignored by the card.
	 * @throws Exception
	 */
	public void initCard_Gesundheitskarte(int port,
			Versichertenstammdaten daten, Secret pin, PrivateKey privkeyEGK,
			PublicKey providerKey, SignedData sigdaten, ZertifikatPatient zert,
			ZertifikatTrustedThirdParty zertTTP, byte zustand)
			throws java.lang.Exception {
		byte cardCode = 0x0;
		switch (port) {
			case Ports.Kiosk2Gesundheitskarte_default :
				cardCode = Code.GESUNDHEITSKARTE;
				break;
			default :
				stop();
				break;
		}
		byte[] apdu = {0, 4, 0, 0, 0, cardCode};
		apdu = ByteArray.append(apdu, (daten != null)
				? encode(daten)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (pin != null)
				? encode(pin)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (privkeyEGK != null)
				? encode(privkeyEGK)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (providerKey != null)
				? encode(providerKey)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (sigdaten != null)
				? encode(sigdaten)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zert != null)
				? encode(zert)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zertTTP != null)
				? encode(zertTTP)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, new byte[]{Code.BYTE, zustand});
		transmit(apdu, port);
	}
	/**
	 * This method initializes the card with the given parameters that correspond 
	 * to the card attributes. A null value will be ignored by the card.
	 * @throws Exception
	 */
	public void initCard_HeilberufsausweisArzt(int port, Secret pin,
			PrivateKey privkeyHBA, ZertifikatLeistungserbringer zert,
			ZertifikatTrustedThirdParty zertTTP, byte zustand)
			throws java.lang.Exception {
		byte cardCode = 0x0;
		switch (port) {
			case Ports.Kiosk2Gesundheitskarte_default :
				cardCode = Code.GESUNDHEITSKARTE;
				break;
			default :
				stop();
				break;
		}
		byte[] apdu = {0, 4, 0, 0, 0, cardCode};
		apdu = ByteArray.append(apdu, (pin != null)
				? encode(pin)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (privkeyHBA != null)
				? encode(privkeyHBA)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zert != null)
				? encode(zert)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zertTTP != null)
				? encode(zertTTP)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, new byte[]{Code.BYTE, zustand});
		transmit(apdu, port);
	}
	/**
	 * This method initializes the card with the given parameters that correspond 
	 * to the card attributes. A null value will be ignored by the card.
	 * @throws Exception
	 */
	public void initCard_HeilberufsausweisApotheker(int port, Secret pin,
			PrivateKey privkeyHBA, ZertifikatLeistungserbringer zert,
			ZertifikatTrustedThirdParty zertTTP, byte zustand)
			throws java.lang.Exception {
		byte cardCode = 0x0;
		switch (port) {
			case Ports.Kiosk2Gesundheitskarte_default :
				cardCode = Code.GESUNDHEITSKARTE;
				break;
			default :
				stop();
				break;
		}
		byte[] apdu = {0, 4, 0, 0, 0, cardCode};
		apdu = ByteArray.append(apdu, (pin != null)
				? encode(pin)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (privkeyHBA != null)
				? encode(privkeyHBA)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zert != null)
				? encode(zert)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, (zertTTP != null)
				? encode(zertTTP)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, new byte[]{Code.BYTE, zustand});
		transmit(apdu, port);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUNotfalldatenLoeschen(UNotfalldatenLoeschen inmsg)
			throws java.lang.Exception {

		if (((zustand == ZustandKiosk.IDLEKIOSK && AuthEGK) && schluesselAusgetauscht)) {
			setZustand(ZustandKiosk.LOESCHENOTFALLDATENA);
			sendMsg(new ErfrageNonceNotfalldatenLoeschen(),
					Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeNonce(SendeNonce inmsg) throws java.lang.Exception {
		Nonce no = inmsg.getNonce();
		if (zustand == ZustandKiosk.LOESCHENOTFALLDATENA) {
			setZustand(ZustandKiosk.LOESCHENOTFALLDATENB);
			String ls = "";
			NonceStringData nsd = new NonceStringData(no, ls);
			EncDataSymm ed = EncDataSymm.encrypt(sessionkey, nsd);
			sendMsg(new LoescheNotfalldaten(ed),
					Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processBestaetigeLoeschenNotfalldaten(
			BestaetigeLoeschenNotfalldaten inmsg) throws java.lang.Exception {

		if (zustand == ZustandKiosk.LOESCHENOTFALLDATENB) {
			setZustand(ZustandKiosk.IDLEKIOSK);
			sendMsg(new UBestaetigeLoeschenNotfalldaten());
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processULeseStammUndNotfalldaten(
			ULeseStammUndNotfalldaten inmsg) throws java.lang.Exception {

		if (((zustand == ZustandKiosk.IDLEKIOSK && AuthEGK) && schluesselAusgetauscht)) {
			setZustand(ZustandKiosk.LESESTAMMDATEN);
			setNonce(Nonce.generateNonce());
			NonceData nd = new NonceData(nonce);
			EncDataSymm ed = EncDataSymm.encrypt(sessionkey, nd);
			sendMsg(new LeseStammUndNotfalldaten(ed),
					Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeStammUndNotfalldaten(
			SendeStammUndNotfalldaten inmsg) throws java.lang.Exception {
		EncDataSymm eds = inmsg.getSd();
		StammUndNotfalldaten sd = (StammUndNotfalldaten) (EncDataSymm.decrypt(
				sessionkey, eds));
		if ((zustand == ZustandKiosk.LESESTAMMDATEN && sd.getNonce().equals(
				nonce))) {
			setZustand(ZustandKiosk.IDLEKIOSK);
			sendMsg(new USendeStammUndNotfalldaten(sd.getNotfalldaten(),
					sd.getAnzahlRezepte(), sd.getVsd()));
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUAuthEGKUndKiosk(UAuthEGKUndKiosk inmsg)
			throws java.lang.Exception {

		if (zustand == ZustandKiosk.IDLEKIOSK) {
			setZustand(ZustandKiosk.AUTHKIOSKA);
			sendMsg(new SendeZertKiosk(zert),
					Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeZertEGK(SendeZertEGK inmsg)
			throws java.lang.Exception {
		EncDataAsymm ed = inmsg.getNd();
		ZertifikatPatient z = inmsg.getZ();
		NonceData nd = (NonceData) (EncDataAsymm.decrypt(privkey, ed));
		if (((z.verifyCertificate(zertTTP.getData().getPubkey()) && zustand == ZustandKiosk.AUTHKIOSKA) && z
				.getData().getId() == Constants.idGesundheitskarte)) {
			setZertEGK(z);
			setNonce(Nonce.generateNonce());
			NonceData ndd = new NonceData(nonce);
			EncDataAsymm eds = EncDataAsymm.encrypt(z.getData().getPubkey(),
					ndd);
			setZustand(ZustandKiosk.AUTHKIOSKB);
			sendMsg(new SendeNonces(nd.getNonce(), eds),
					Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processBestaetigeNonce(BestaetigeNonce inmsg)
			throws java.lang.Exception {
		Nonce n = inmsg.getN();
		if ((zustand == ZustandKiosk.AUTHKIOSKB && n.equals(nonce))) {
			setAuthEGK(true);
			setZustand(ZustandKiosk.IDLEKIOSK);
			sendMsg(new UAuthOK());
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUPINEingabeKiosk(UPINEingabeKiosk inmsg)
			throws java.lang.Exception {
		Secret pin = inmsg.getPin();
		if ((zustand == ZustandKiosk.IDLEKIOSK && AuthEGK)) {
			setZustand(ZustandKiosk.PINKIOSKA);
			setPinegk(pin);
			sendMsg(new ErfrageNoncePIN(), Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeNoncePIN(SendeNoncePIN inmsg)
			throws java.lang.Exception {
		Nonce n = inmsg.getNonce();
		if (zustand == ZustandKiosk.PINKIOSKA) {
			PINData pindata = new PINData(pinegk, n);
			EncDataAsymm eds = EncDataAsymm.encrypt(zertEGK.getData()
					.getPubkey(), pindata);
			setZustand(ZustandKiosk.PINKIOSKB);
			sendMsg(new SendePIN(eds), Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processBestaetigePIN(BestaetigePIN inmsg)
			throws java.lang.Exception {

		if (zustand == ZustandKiosk.PINKIOSKB) {
			setZustand(ZustandKiosk.IDLEKIOSK);
			sendMsg(new UBestaetigePIN());
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUSchluesselaustausch(USchluesselaustausch inmsg)
			throws java.lang.Exception {

		if ((zustand == ZustandKiosk.IDLEKIOSK && AuthEGK)) {
			setZustand(ZustandKiosk.SCHLUESSELKIOSKA);
			sendMsg(new ErfrageNonceSchluesselaustausch(),
					Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeNonceSchluesselaustausch(
			SendeNonceSchluesselaustausch inmsg) throws java.lang.Exception {
		EncDataAsymm ed = inmsg.getNd();
		if (zustand == ZustandKiosk.SCHLUESSELKIOSKA) {
			NonceData nd = (NonceData) (EncDataAsymm.decrypt(privkey, ed));
			setSessionkey(SymmKey.generateKey());
			KeyData kd = new KeyData(nd.getNonce(), sessionkey);
			EncDataAsymm eds = EncDataAsymm.encrypt(zertEGK.getData()
					.getPubkey(), kd);
			setZustand(ZustandKiosk.SCHLUESSELKIOSKB);
			sendMsg(new SendeSessionkeyKiosk(eds),
					Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSchluesselKioskOK(SchluesselKioskOK inmsg)
			throws java.lang.Exception {

		if (zustand == ZustandKiosk.SCHLUESSELKIOSKB) {
			setSchluesselAusgetauscht(true);
			setZustand(ZustandKiosk.IDLEKIOSK);
			sendMsg(new USchluesselKioskOK());
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processULeseRezept(ULeseRezept inmsg)
			throws java.lang.Exception {
		int i = inmsg.getIndex();
		if (((zustand == ZustandKiosk.IDLEKIOSK && AuthEGK) && schluesselAusgetauscht)) {
			setZustand(ZustandKiosk.LESEREZEPT);
			setNonce(Nonce.generateNonce());
			NonceDataAndIndex nd = new NonceDataAndIndex(nonce, i);
			EncDataSymm eds = EncDataSymm.encrypt(sessionkey, nd);
			sendMsg(new LeseRezept(eds), Ports.Kiosk2Gesundheitskarte_default);
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processSendeRezeptdaten(SendeRezeptdaten inmsg)
			throws java.lang.Exception {
		EncDataSymm ed = inmsg.getNur();
		NonceUndRezept nur = (NonceUndRezept) (EncDataSymm.decrypt(sessionkey,
				ed));
		if ((zustand == ZustandKiosk.LESEREZEPT && nur.getNonce().equals(nonce))) {
			setZustand(ZustandKiosk.IDLEKIOSK);
			sendMsg(new USendeRezept(nur.getRd()));
		} else {
			ABORTKIOSK();
			stop();
		}
	}

	private void ABORTKIOSK() throws TerminalException {
		setZustand(ZustandKiosk.IDLEKIOSK);
		setAuthEGK(false);
		setSchluesselAusgetauscht(false);
		stop();
	}

	public boolean getAuthEGK() {
		return AuthEGK;
	}

	public boolean getSchluesselAusgetauscht() {
		return schluesselAusgetauscht;
	}

	public PrivateKey getPrivkey() {
		return privkey;
	}

	public ZertifikatPatient getZertEGK() {
		return zertEGK;
	}

	public Nonce getNonce() {
		return nonce;
	}

	public Secret getPinegk() {
		return pinegk;
	}

	public SymmKey getSessionkey() {
		return sessionkey;
	}

	public ZertifikatTrustedThirdParty getZertTTP() {
		return zertTTP;
	}

	public ZertifikatKiosk getZert() {
		return zert;
	}

	public byte getZustand() {
		return zustand;
	}

	public void setAuthEGK(boolean AuthEGK) {
		this.AuthEGK = AuthEGK;
	}

	public void setSchluesselAusgetauscht(boolean schluesselAusgetauscht) {
		this.schluesselAusgetauscht = schluesselAusgetauscht;
	}

	public void setPrivkey(PrivateKey privkey) {
		this.privkey = privkey;
	}
	public void setZertEGK(ZertifikatPatient zertEGK) {
		this.zertEGK = zertEGK;
	}
	public void setNonce(Nonce nonce) {
		this.nonce = nonce;
	}
	public void setPinegk(Secret pinegk) {
		this.pinegk = pinegk;
	}
	public void setSessionkey(SymmKey sessionkey) {
		this.sessionkey = sessionkey;
	}
	public void setZertTTP(ZertifikatTrustedThirdParty zertTTP) {
		this.zertTTP = zertTTP;
	}
	public void setZert(ZertifikatKiosk zert) {
		this.zert = zert;
	}
	public void setZustand(byte zustand) {
		this.zustand = zustand;
	}

	protected void stop() throws TerminalException {
		currentGate.callConstraints();
		throw new TerminalException("Kiosk");
	}

}
