package generated.eGKmitServices.server.krankenkasse;

import java.io.FileInputStream;
import java.net.InetSocketAddress;
import java.security.KeyStore;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.net.ssl.*;
import javax.swing.JOptionPane;
import javax.xml.ws.Endpoint;
import javax.xml.ws.soap.Addressing;
import javax.xml.ws.BindingProvider;

import swt.util.HexString;

import com.sun.net.httpserver.*;
import com.sun.xml.ws.developer.Stateful;
import com.sun.xml.ws.developer.StatefulWebServiceManager;

/**
 *
 * @author Marian Borek
 */

@WebService
public class Krankenkasse {

	private PublicKey puKey;

	private PrivateKey privKey;

	private ZertifikatTrustedThirdParty zertTTP;

	private ListOfVersichertenstammdaten db;

	private Endpoint endpoint;
	private HttpsServer httpsServer;

	public Krankenkasse() throws java.lang.Exception {

		puKey = new PublicKey();
		privKey = new PrivateKey();
		zertTTP = new ZertifikatTrustedThirdParty();
		db = new ListOfVersichertenstammdaten();

	}

	public Krankenkasse(ListOfVersichertenstammdaten db, PrivateKey privKey,
			PublicKey puKey) throws java.lang.Exception {

		this.db = db;
		this.privKey = privKey;
		this.puKey = puKey;

		zertTTP = new ZertifikatTrustedThirdParty();

	}

	private Message sendMsg(Message msg) {

		return msg;

	}

	private Message sendMsg(Message msg, int port) throws java.lang.Exception {

		return sendMsg(msg, port, false, false);

	}
	private Message sendMsg(Message msg, int port,
			Boolean openSessionBeforeSend, Boolean closeSessionAfterReceive)
			throws java.lang.Exception {

		Message response;

		switch (port) {
			default :
				stop();
				return null;
		}
	}

	private Message processMessage(Message inmsg) throws java.lang.Exception {
		switch (inmsg.getCode()) {
			case Code.CARDDATA :
				return processCardData((CardData) inmsg);
			default :
				stop();
				return null;
		}
	}

	@WebMethod
	public MessageWrapper process(MessageWrapper msg) throws ServiceException {
		MessageWrapper m = null;
		try {
			m = new MessageWrapper(processMessage(msg.getMsg()));
		} catch (java.lang.Exception e) {
			e.printStackTrace();
			if (e instanceof ServiceException)
				throw (ServiceException) e;
			else
				throw new ServiceException("Error when calling process method");
		}
		return m;
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private Message processCardData(CardData inmsg) throws java.lang.Exception {
		synchronized (this) {
			Nonce n = inmsg.getNonce();
			EncDataAsymm ed = inmsg.getDaten();
			SignedData sig = inmsg.getSigdaten();
			ZertifikatPatient zertEGK = inmsg.getZertEGK();
			System.out.println("Modulus privKey: " +HexString.hexify(privKey.getModulus()));
			Versichertenstammdaten vsd = (Versichertenstammdaten) (EncDataAsymm
					.decrypt(privKey, ed));
			Versichertenstammdaten newData = db.get(vsd.getVersichertennr());
			SignedData newsig = SignedData.sign(privKey, newData);
			UpdateAuth ua = new UpdateAuth(n, newData);
			SignedData sigWithNonce = SignedData.sign(privKey, ua);
			EncDataAsymm eds = EncDataAsymm.encrypt(zertEGK.getData()
					.getPubkey(), newData);
			return sendMsg(new Update(eds, newsig, sigWithNonce));
		}
	}

	public PublicKey getPuKey() {
		return puKey;
	}

	public PrivateKey getPrivKey() {
		return privKey;
	}

	public ZertifikatTrustedThirdParty getZertTTP() {
		return zertTTP;
	}

	public ListOfVersichertenstammdaten getDb() {
		return db;
	}

	public void setPuKey(PublicKey puKey) {
		this.puKey = puKey;
	}
	public void setPrivKey(PrivateKey privKey) {
		this.privKey = privKey;
	}
	public void setZertTTP(ZertifikatTrustedThirdParty zertTTP) {
		this.zertTTP = zertTTP;
		this.zertTTP.setData(zertTTP.getData());
		this.zertTTP.setSignedCert(zertTTP.getSignedCert());
	}
	public void setDb(ListOfVersichertenstammdaten db) {
		this.db = db;
	}

	public void startService() throws java.lang.Exception {

		endpoint = Endpoint.publish(
				"http://localhost:8000/KrankenkasseService", this);

	}
	public void stopService() {
		endpoint.stop();

	}
	public static void main(String[] args) throws java.lang.Exception {
		Krankenkasse s = new Krankenkasse();
		s.startService();
		JOptionPane.showMessageDialog(null, "Server beenden");
		s.stopService();
	}

	protected void stop() throws ServiceException {

		throw new ServiceException("Krankenkasse");
	}

}
