package generated.eGKmitServices.server.krankenkasse;

import java.math.BigInteger;
import java.security.spec.InvalidKeySpecException;
import java.security.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
@XmlAccessorType(XmlAccessType.FIELD)
public class PublicKey extends Key implements Codeable, PlainData, SignData {

	public final static short MODULUSLENGTH = 128;
	public final static short EXPONENTLENGTH = 3;
	public final static String cryptProvider = "BC";

	private byte[] modulus;

	private byte[] pubexponent = {0x01, 0x00, 0x01};

	public PublicKey() {

		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());

	}
	public PublicKey(byte[] modulus) throws InvalidKeySpecException,
			NoSuchAlgorithmException, NoSuchProviderException {
		this();

		setKey(modulus);

	}

	public boolean equals(PublicKey other) {
		return Arrays.equals(modulus, other.modulus)
				&& Arrays.equals(pubexponent, other.pubexponent);
	}

	public byte getCode() {
		return Code.PUBLICKEY;
	}

	public void setKey(byte[] modulus) throws InvalidKeySpecException,
			NoSuchAlgorithmException, NoSuchProviderException {
		this.modulus = modulus.clone();
	}

	public void copy(PublicKey p) {

		if (p.getModulus() != null) {
			try {
				setKey(p.getModulus());
			} catch (InvalidKeySpecException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchAlgorithmException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	public boolean isPublicKey() {
		return true;
	}

	public java.security.PublicKey toAPIKey() throws Exception {
		BigInteger mod = new BigInteger(1, this.modulus);
		BigInteger pub = new BigInteger(1, this.pubexponent);
		KeyFactory rsakf = KeyFactory.getInstance("RSA", cryptProvider);
		java.security.PublicKey apikey = (java.security.PublicKey) rsakf
				.generatePublic(new java.security.spec.RSAPublicKeySpec(mod,
						pub));
		return apikey;
	}

	public byte[] getModulus() {
		return modulus;
	}

	public byte[] getPubexponent() {
		return pubexponent;
	}

}
