package generated.eGKmitServices.server.krankenkasse;

/**
 * Generated Class
 * 
 */

public class ZertifikatTrustedThirdParty implements Codeable {

	private ZertifikatTTPData data;

	private SignedData signedCert;

	public ZertifikatTrustedThirdParty() {

		data = new ZertifikatTTPData();
		signedCert = new SignedData();

	}

	public ZertifikatTrustedThirdParty(SignedData signedCert,
			ZertifikatTTPData data) {

		this.signedCert = signedCert;
		this.data = data;

	}

	public ZertifikatTTPData getData() {
		return data;
	}

	public SignedData getSignedCert() {
		return signedCert;
	}

	public void setData(ZertifikatTTPData data) {
		this.data = data;
		this.data.setName(data.getName());
		this.data.setPubkey(data.getPubkey());
	}
	public void setSignedCert(SignedData signedCert) {
		this.signedCert = signedCert;
		this.signedCert.setSigned(signedCert.getSigned());
	}

	public byte getCode() {
		return Code.ZERTIFIKATTRUSTEDTHIRDPARTY;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatTrustedThirdParty other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.signedCert.equals(other.signedCert))
			return false;
		return true;
	}

	public void copy(ZertifikatTrustedThirdParty from) {
		this.data.copy(from.data);
		this.signedCert.copy(from.signedCert);
	}

	public ZertifikatTrustedThirdParty copy() {
		ZertifikatTrustedThirdParty object = new ZertifikatTrustedThirdParty();
		object.copy(this);
		return object;
	}

	public boolean verifyCertificate(PublicKey pubkey) throws Exception {
		return SignedData.verify(pubkey, signedCert, data);
	}

	public static ZertifikatTrustedThirdParty generateCertificate(
			PrivateKey issuerPrivateKey, String name, PublicKey pubkey)
			throws Exception {
		ZertifikatTTPData dataclass = new ZertifikatTTPData(name, pubkey);
		SignedData s = SignedData.sign(issuerPrivateKey, dataclass);

		return new ZertifikatTrustedThirdParty(s, dataclass);

	}

}
